/*
  IIPImage Javascript Viewer <http://iipimage.sourceforge.net>
                      Version 3.3

  Copyright (c) 2007 Joseph Padfield <joseph.padfield@ng-london.org.uk>
	and Ruven Pillay <ruven@users.sourceforge.net>

  Built using the Mootools javascript framework <http://www.mootools.net>


   ---------------------------------------------------------------------------

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   ---------------------------------------------------------------------------


  Example:

   iip = new IIP( 'div_id', 'http://www.server.com/fcgi-bin/iipsrv.fcgi' );

   where the arguments are:
 	i) The id of the main div element in which to create the viewer window
	ii) The iipsrv server full URL

   Note: the new class instance must be assigned to the global variable "iip" in this version.
       : requires mootools version 1.2 <http://www.mootools.net>

*/

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
// Things that are not generic to any iip instance
var keywords = 0;
var doJump = 0;
var ow = 0;
var openControl = 0;
// $('emailLink') is also processed

function getElementsByClassName(strClassName, strTagName, oElm) 
	{
  add2FunctionString ('getElementsByClassName('+strClassName+', '+strTagName+', '+oElm+')', 0, 0, 0); 
  var arrElements = (strTagName == "*" && document.all) ? 
		document.all : oElm.getElementsByTagName(strTagName);

  var arrReturnElements = new Array();
  
	strClassName = strClassName.replace(/\-/g, "\\-");
  
	var oRegExp = new RegExp("(^|\\s)" + strClassName + "(\\s|$)");
  var oElement;
  
	for(var i=0; i<arrElements.length; i++){
  	oElement = arrElements[i];      
    if(oRegExp.test(oElement.className)) {
    	arrReturnElements.push(oElement);}}

	return (arrReturnElements)
	}
	
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

function getURL ()
	{
  add2FunctionString ('getURL()', 0, 0, 0);
	var myRe = /(.+)([?].*)/;
	var myArray = myRe.exec(document.URL);

	if (myArray)
		{var path = myArray[1];}
	else
		{var path = document.URL;}

	return (path);
	}



//Start view point [0:'centre', 1:'top left']
var start_point = 1;//startPoint; Move this to the php page
var stop_browser_cache = false;//true;
var linkHere = "";

if (grid_max_x)
	{
	if (grid_max_x && grid_max_x > grid_max_y)
		{var rlimit = 2 * grid_max_x;}
	else if (grid_max_x && grid_max_y > grid_max_x)
		{var rlimit = 2 * grid_max_y;}
	else
		{var rlimit = 20000;}

var resolution_limit = 0;

if (grid_max_x < grid_max_y)
	{resolution_limit = rlimit * grid_cols;}
else
	{resolution_limit = rlimit * grid_rows;}

var server = '/fcgi-bin/iipsrv.fcgi';
var qua = '&QLT=75';
var selected = -1;
var unloaded = 0;
var sel_col = -1;
var sel_row = -1;

//var sortby = "ObjectCode";
//var sortby = "";//"ObjectAlphaSort";
}

var tiles = new Array;

var images = "./graphics/";
//var tt = 0;
//var aj_to = 0;
//var aj_f = 0;
//var first = true;
var onGo = true;
var remainder = null;
var crefresh = true;
var lastim = new Array();

var spWidth = 275;
var pgBorder = 5;
var pnBorder = 2;
var bnHeight = 80;
var dtSpacer = 3;
var slider ="";

var searchRequest = new Request( 
	{
	method: 'get',
	url: 'blank.html',
	autoCancel: true,  
  data: { 'do' : '1' }, 
  onComplete: function(response) {} 
  }).send();

var parentPage = "http://www.nationalgallery.org.uk";

//////////////////
var display_warning = false;
//////////////////

////////////////////////////////////////////////////////////////////////////////
//A set of controls/information windows can be added to the page by recreating 
//these functions.
///////////////////////////////////////////////////////////////////////////////






function keywordsToList (cArr)
	{
  add2FunctionString ('keywordsToList('+cArr+')', 0, 0, 0);
	var st = '';
	
	if (cArr)
		{var tmp = cArr;}
	else
		{var tmp = keywords;}

	if (tmp.length > 1)
		{
		var cno = 0;

		for ( keyNo in tmp ) {	
			if ( (typeof tmp[keyNo]) == 'object' && tmp[keyNo].length == 3) 
				{
				cno++;
				var fname = field2name (tmp[keyNo][0]);

				var ty = tmp[keyNo];

				if (cno == (tmp.length - 1))
					{st = st + fname +'\'' + tmp[keyNo][1] + '\'</font> and <font class="kw">';}
				else if (cno == tmp.length)
					{st = st + fname +'\'' + tmp[keyNo][1] + '\'</font>';}
				else
					{st = st + fname +'\'' + tmp[keyNo][1] + '\'</font>, <font class="kw">';}
				}}

		st = '<font class="kw">'+st;

		//alert (keywords);		alert (tmp);
		}
	else if (tmp.length == 1)
		{
		var fname = field2name (tmp[0][0]);
		st = '<font class="kw">'+fname+'\''+tmp[0][1]+'\'</font>';}

	return (st);
	}

function keywordsToListSimp (cArr)
	{
  add2FunctionString ('keywordsToListSimp ('+cArr+')', 0, 0, 0);
	var st = '';
	
	if (cArr)
		{var tmp = cArr;}
	else
		{var tmp = keywords;}

	if (tmp.length > 1)
		{
		var cno = 0;

		for ( keyNo in tmp ) {	
			if ( (typeof tmp[keyNo]) == 'object' && tmp[keyNo].length == 3) {
				cno++;
				if (cno == (tmp.length - 1))
					{st = st + '\'' + tmp[keyNo][1] + '\' and ';}
				else if (cno == tmp.length)
					{st = st + '\'' + tmp[keyNo][1] + '\'';}
				else
					{st = st + '\'' + tmp[keyNo][1] + '\', ';}
				}}

		st = 'keywords '+st;
		}
	else if (tmp.length == 1)
		{st = 'keyword \''+tmp[0][1]+'\'';}

	return (st);
	}


function getKeyField (cvalue)
	{
  add2FunctionString ('getKeyField ('+cvalue+')', 0, 0, 0);
	var cfield = false;

	if (keywords.length)
		{		
		for ( keyNo in keywords ) {	
			if ( keywords[keyNo][1] == cvalue )
				{cfield = keywords[keyNo][0];}
			}
		}

	return (cfield);
	}

function displayKeywords ()
	{
  add2FunctionString ('displayKeywords ()', 0, 0, 0);
	//showDB ("displayKeywords");
	var ct = 'KEYWORDS:('+keywords.length+')@@';
	var st = '';
	$('searchDetails').set('html', '');

	if (keywords.length)
		{		
		for ( keyNo in keywords ) {	
			if ( (typeof keywords[keyNo]) == 'object' && keywords[keyNo].length == 3) {
				ct = ct + keywords[keyNo][0] + ' : ' + keywords[keyNo][1] + "@@";}}
		
		//Search limited to: *search term here* (red/bold)
		st = 'Search limited by: '+ keywordsToList();
		$('searchDetails').set('html', st);
	
		$('cb').style.display = 'block';
		addClick ($('csearch'), '', '', 1);
	
		infoBox ($('csearch'), 'Click to clear all the current search limitations.', $('Explore'));

		var kwno = 0;

		$$('.kw').each(function(cur){

			if (cur.textContent)
				{var txtc = cur.textContent;}
			else
				{var txtc = cur.innerText;}

			ct = ct + txtc + "@@";

			var re = txtc;

			var myRe = /(.+)[:][ ][\'](.+)[\']/;
			var myArray = myRe.exec(txtc);

			if (myArray)
				{var cfield = name2field (myArray[1]+': ');
				 var cvalue = myArray[2];}
			else
				{var cfield = 'missed';
				 var cvalue = 'missed';}

			addClick (cur, cfield, cvalue, 0);
			infoBox(cur, 'Click to remove search term: '+txtc, $('Explore'));

			kwno++;
			});
		}
	else
		{		
		$('cb').style.display = 'none';
		st = 'Displaying the full set of '+maxNo+' images';

		var theText = document.createTextNode(st);
  	$('searchDetails').appendChild(theText);
		}
	
	var w = $('orderBy').selectedIndex;
	var selected_text = $('orderBy').options[w].text;

	$('fingertips').set('html', 'Displaying '+no_ims+' of '+maxNo+' paintings, ordered by '+
		selected_text+'');

	}


function getKeywords ()
	{
  add2FunctionString ('getKeyWords()', 0, 0, 0);
	var ct = 'KEYWORDS:('+keywords.length+')<br>';
	var st = '';

	if (keywords.length)
		{		
		for ( keyNo in keywords ) {	
			if ( (typeof keywords[keyNo]) == 'object' && keywords[keyNo].length == 3) {
				ct = ct + keywords[keyNo][0] + ' : ' + keywords[keyNo][1] + "<br>";}}
		
		st = 'The displayed images are being '+
		'limited by the '+ keywordsToList();
		}
	else
		{st = 'Displaying the full set of '+maxNo+' available images';}
	
	var w = $('orderBy').selectedIndex;
	var selected_text = $('orderBy').options[w].text;

	$('searchDetails').set('html', st);
	$('fingertips').set('html', 'Displaying '+no_ims+' of '+maxNo+' images, ordered by '+
		selected_text+'');
	}



function createControls() {}

function siteConditions() {}

function updateObjectMenu () {}

function refreshCaption () {}

function imDetails (no) {
	
  add2FunctionString ('imDetails('+no+')', 0, 0, 0);
  
	var search_path = "ajax.php?what=details&val="+no+"&crop="+display_warning+
		"&whichdb="+whichDB+"&whichtable="+whichTable;

	//if (ow)
	//	{openWindow (search_path);}

	searchRequest = new Request( 
		{
		method: 'get',
		url: search_path,
		autoCancel: true, 
		async:false, 
    //data: { 'do' : '1' },  
    onRequest: function() { /*alert('Request made. Please wait...');*/ }, 
		onFailure: function() {alert('FAILED')}, 
    onComplete: function(response) { 
			var loc_pd = new Array ();
			eval ("loc_pd = "+response);}  
    });

	searchRequest.send();
	}

////////////////////////////////////////////////////////////////////////////////

var ad = new Date();
var previous = ad.getTime();
var delayLength = 20;
 
function delayRun(func) {add2FunctionString ('imDetails('+no+')', 0, 0, 0);
	previous = previous + delayLength;
	var nd = new Date();
	var now = nd.getTime();
	var then = previous - now;
	setTimeout (func, then);}


function clearCover () {
		var selcov = getElementsByClassName("cover", "img", $('target'));
	  for(var i=0; i<selcov.length; i++) 
			{selcov[i].style.border = 'none';}
			
		var selcov = getElementsByClassName("notPublic", "img", $('target'));
	  for(var i=0; i<selcov.length; i++) 
			{selcov[i].style.border = '1px solid red';}}


////////////////////////////////////////////////////////////////////////////////


// Global instance of our IIP object for use by the TargetDrag class
var iip;

/* Create our own class inherited from Drag.Move for constrained dragging of
   the main target window
 */

/* Create our own class inherited from Drag for constrained dragging of
   the main target window
 */
var TargetDrag = new Class({

   Extends: Drag,

   // Simply copy the parent class initialize function
   initialize: function(){      
      var params = Array.link(arguments, {'options': Object.type, 'element': $defined});
      this.element = $(params.element);
      this.document = this.element.getDocument();
      this.setOptions(params.options || {});
      var htype = $type(this.options.handle);
      this.handles = (htype == 'array' || htype == 'collection') ? $$(this.options.handle) : $(this.options.handle) || this.element;
      this.mouse = {'now': {}, 'pos': {}};
      this.value = {'start': {}, 'now': {}};

      this.selection = (Browser.Engine.trident) ? 'selectstart' : 'mousedown';

      this.bound = {
	start: this.start.bind(this),
	check: this.check.bind(this),
	drag: this.drag.bind(this),
	stop: this.stop.bind(this),
	cancel: this.cancel.bind(this),
	eventStop: $lambda(false)
      };
      this.attach();

      // To fix a problem with IE7 not dragging properly
      if(Browser.Engine.trident) this.handles.ondragstart = function(){ return false; };

    },

    // Create our own drag implementation
    drag: function(event){
      if (this.options.preventDefault) event.preventDefault();
      this.mouse.now = event.page;
      for (var z in this.options.modifiers){
	if (!this.options.modifiers[z]) continue;
	this.value.now[z] = this.mouse.now[z] - this.mouse.pos[z];

	if( z == 'x' ){
	  if( iip.rgn_x - this.value.now[z] < 0 ){
	    this.value.now[z] = iip.rgn_x;
	    this.out = true;
	  }
	  if( iip.wid > iip.rgn_w ){
	    if( iip.rgn_x - this.value.now[z] > iip.wid - iip.rgn_w ){
	      this.value.now[z] = -(iip.wid - iip.rgn_w - iip.rgn_x);
	      this.out = true;
	    }
	  }
	  else{
	    this.value.now[z] = 0;
	    this.out = true;
	  }
	}
	if( z == 'y' ){
	  if( iip.rgn_y - this.value.now[z] < 0 ){
	    this.value.now[z] = iip.rgn_y;
	    this.out = true;
	  }
	  if( iip.hei > iip.rgn_h ){
	    if( iip.rgn_y - this.value.now[z] > iip.hei - iip.rgn_h ){
	      this.value.now[z] = -(iip.hei - iip.rgn_h - iip.rgn_y);
	      this.out = true;
	    }
	  }
	  else{
	    this.value.now[z] = 0;
	    this.out = true;
	  } 
	}

	if (this.options.grid[z]) this.value.now[z] -= (this.value.now[z] % this.options.grid[z]);
	if (this.options.style) this.element.setStyle(this.options.modifiers[z], this.value.now[z] + this.options.unit);
	else this.element[this.options.modifiers[z]] = this.value.now[z];
      }
      this.fireEvent('drag', this.element);
    }

});



/* nIIP Javascript Class
 */
var nIIP = new Class({

/* Initialize some variables. The constructor takes 2 arguments:
 i) The id of the main div element in which to create the viewer window
 ii) The iipsrv server full URL
*/
initialize: function( main_id, server ) 
	{
	this.impos = 0;
	this.impos_r = 0;
	this.impos_c = 0;
	this.jump2selected = false;
	this.jump2view = false;

  this.source = main_id;
  this.server = server;
  this.fif = '';
  this.max_width = 0;
  this.max_height = 0;
  this.min_x = 0;
  this.min_y = 0;
  this.nav_x = 0;
  this.nav_y = 0;
  this.sds = "0,90";
  this.contrast = 1.0;
  this.wid = 0;
  this.hei = 0;
  this.rgn_x = 0;
  this.rgn_y = 0;
  this.rgn_w = this.wid;
  this.rgn_h = this.hei;

	this.zoomStep;

  this.xfit = 0;
  this.yfit = 0;
  this.navpos = [0,0];
  this.tarpos = [0,0];
  this.tileSize = [0,0];
  this.resolution = null;
  this.refresher = null;
  this.loader = null;
	
  this.max_res = max_res;
  this.no_ims = no_ims;
  this.g_rows = grid_rows;
  this.g_cols = grid_cols;
  this.x_s = grid_max_x;
  this.y_s = grid_max_y;
  this.min_x_s = 0;
  this.min_y_s = 0;
  this.help = help;
	
  this.count = 0;
	
  this.min_x_arr = new Array();
  this.min_y_arr = new Array();

	this.startLoad = 0;

	this.display_ims = all_ims;

	this.newset = true;
	this.display_order = new Array();

	this.keywords = new Array();

	this.ajaxCalls = new Array();
	this.oldTiles = new Array('Start');
	this.newTiles = new Array();
	this.newTiles_to = new Array();

	//variable used in positioning images and processing zooms
	this.grid_wid = 0;
	this.grid_hei = 0;
	this.xscr_tiles = 0;
	this.yscr_tiles = 0;
	this.start_gx = 0;
	this.start_gy = 0;
	this.end_gx = 0;
	this.end_gy = 0;
	this.xscr_grids = 0;
	this.yscr_grids = 0;
	this.allow_xg = 0;
	this.allow_yg = 0;

	this.mi_info = false;

	/* Load us up when the DOM is fully loaded! 
   */
	window.addEvent( 'domready', function(){ 
		this.load()
		}.bind(this) );
  },
  

  /* Create the appropriate CGI strings and change the image sources
   */
  requestImages: function() {		
    // Clear our tile refresher
    if( this.refresher ){
      $clear( this.refresher );
      this.refresher = null;
    }

    // Set our cursor and activate our loading animation
		if ($('target')) {$('target').style.cursor = 'wait';}
    if ($('loading')) 
			{$('loading').setOpacity(1);
    	 $('loading').style.zIndex = '2';}

    // Load our image mosaic
		this.loadTiles();

    // Create a tile refresher to check for unloaded tiles
    this.refresher = this.refresh.periodical( 1000, this );
  },

  /* Create the appropriate CGI strings and change the image sources
   */
  refreshImages: function() {		
    // Clear our tile refresher
    if( this.refresher ){
      $clear( this.refresher );
      this.refresher = null;
    }

    // Set our cursor and activate our loading animation
    $('target').style.cursor = 'wait';
    $('loading').setOpacity(1);
    $('loading').style.zIndex = '2';

    // Load our image mosaic
		this.loadTiles();

    // Create a tile refresher to check for unloaded tiles
    this.refresher = this.refresh.periodical( 500, this );
  },


	/* Define various grid sizes and limits at current zoom level
   */
  gridVariables: function() {
    // Define the size of the grid at this level of zoom
		this.grid_wid = this.wid/this.g_cols;
		this.grid_hei = this.hei/this.g_rows;

		//How many full size tiles will fill the screen
		this.xscr_tiles =  Math.ceil(this.rgn_w/this.tileSize[0]);
		this.yscr_tiles =  Math.ceil(this.rgn_h/this.tileSize[1]);
	
		// Get the number of the first grid
		this.start_gx = Math.floor( this.rgn_x / this.grid_wid );
	  this.start_gy = Math.floor( this.rgn_y / this.grid_hei );

		if (this.start_gy < 0)
			{this.start_gy = 0;}

		if (this.start_gx < 0)
			{this.start_gx = 0;}

  	// If our size is smaller than the display window, only process these sections!
	  var lenx = this.rgn_w;
  		if( this.wid < this.rgn_w ) lenx = this.wid;
	  this.end_gx =  Math.floor( (lenx + this.rgn_x) / this.grid_wid );
			if( this.end_gx >= this.g_cols) this.end_gx -= 1;

	  var leny = this.rgn_h;
	    if( this.hei < this.rgn_h ) leny = this.hei;
	  this.end_gy = Math.floor( (leny + this.rgn_y) / this.grid_hei );
			if( this.end_gy >= this.g_rows) this.end_gy -= 1;


		//How many full size grids will be included
		this.xscr_grids =  this.end_gx - this.start_gx;
		this.yscr_grids =  this.end_gy - this.start_gy;

		//To ensure viewer performance limit the number of images returned to the
		//Full number of tiles possible in the viewer.
		this.allow_xg = this.xscr_tiles + 2;
		this.allow_yg = this.yscr_tiles + 2;
		},

	clearTarget: function()
		{
		// Delete our old image mosaic
		// Swapping the source to that of an already loaded images stops IE from
		// continuing to try to load old images.
		this.newTiles = new Array();
		this.newTiles_to = new Array();
		onGo = false;
		//aj_to = 0;
		//aj_f = 0;
		
	  // Stop periodical our tile loaderer
    if( this.loaderer ){
      $clear( this.loader );
      this.loader = null;
    }

		$('target').getChildren().each( function(el)
			{
			el.src = images+'transparentpixel.gif';
			el.dispose();
    	} );

  	$('target').setStyles({
        left: '0px',
        top: '0px'
    	});	
		},

	clearTargetNo: function(no)
		{
		// Delete our old image mosaic
		// Swapping the source to that of an already loaded images stops IE from
		// continuing to try to load old images.
		$('target').getChildren().each( function(el)
			{
			if (el.alt == no)
				{el.src = images+'transparentpixel.gif';
				 el.dispose();}
    	} );
		},

	whichIms: function(var_arr){

		var frac = 0.1;
		var im_no = var_arr[0];
		var im_fif = var_arr[1];
		var grid_max_x = var_arr[2];
		var grid_max_y = var_arr[3];
		var gx = var_arr[4];
		var gy = var_arr[5];
		var gxoffset = var_arr[6];
		var gyoffset = var_arr[7];
		var grid_left = ((gx-this.start_gx)*this.grid_wid - gxoffset);
		var grid_top = ((gy-this.start_gy)*this.grid_hei - gyoffset);

		//var tmp = response.split( "Max-size" );

		if(!var_arr[8]) 
			{
			var frac = 0.1;
			var gl = grid_left + this.grid_wid * 0.1;
			var gt = grid_top + this.grid_hei * 0.1;
			var gw = this.grid_wid * ( 1 - ( 2 * frac));
			var gh = this.grid_hei * ( 1 - ( 2 * frac)); 

			//Image not found on the server so replace with a blank	
			this.insertTile(gl, gt, gw, gh,'blank', 'temp', im_no);
			this.insertTile(grid_left, grid_top, this.grid_wid, this.grid_hei, 
				'blank', 'cover', im_no);
			}
		else
			{
		//var size = tmp[1].split(" ");			
		var im_x = parseInt( var_arr[8] );//size[0].substring(1,size[0].length) );
		var im_y = parseInt(  var_arr[9] );//size[1]);
		//tmp = response.split( "Resolution-number" );
		var im_res = parseInt( var_arr[11] );//tmp[1].substring(1,tmp[1].length) );
		
		if (var_arr[12])
			{var cserver = var_arr[12];}
		else
			{var cserver = this.server;}

		var res_dif = this.max_res - im_res;
			
		if (res_dif && im_res)
			{cres = this.resolution - res_dif;}
		else
			{cres = this.resolution;}

		if (cres < 0)
			{cres = 0;}

		//What is the pixel position for the bottom right corner
		//of the viewer relative to the full grid.
		var rgn_xf = this.rgn_x + this.rgn_w;
		var rgn_yf = this.rgn_y + this.rgn_h;	

		//What are the pixel left&top (relative to the full grid) and 
		//full wid&hei of the current image at this level of zoom 
		var image_wid = (im_x/grid_max_x) * this.grid_wid;
		var image_hei = (im_y/grid_max_y) * this.grid_hei;
		var image_left = (gx * this.grid_wid) + ((this.grid_wid - image_wid)/2);
		var image_top = (gy * this.grid_hei) + ((this.grid_hei - image_hei)/2);	

		//What is the pixel start position for the section of 
		//the image to be displayed relative to the full grid
		var i_rgn_x = image_left;
		if (i_rgn_x < this.rgn_x) i_rgn_x = this.rgn_x;
		var i_rgn_y = image_top;
		if (i_rgn_y < this.rgn_y) i_rgn_y = this.rgn_y;

		//What is the pixel width&height of current displayed image region
		var i_rgn_w = rgn_xf - i_rgn_x;
		if (image_left + image_wid <  rgn_xf) 
			{i_rgn_w = image_left + image_wid - i_rgn_x;}
		var i_rgn_h = rgn_yf - i_rgn_y;
		if (image_top + image_hei <  rgn_yf) 
			{i_rgn_h = image_top + image_hei - i_rgn_y;}
		// Calculate the offset from the tile top left that we want to display.
	  //   Also Center the image if our viewable image is smaller than the window
		var xoffset = Math.floor((i_rgn_x - image_left) % this.tileSize[0]);
		if( grid_left > 0 || i_rgn_x > this.rgn_x ) 
			{xoffset -= (i_rgn_x - this.rgn_x);}
		if( this.wid < this.rgn_w ) 
			{xoffset -=  (this.rgn_w - this.wid)/2;}
				
		var yoffset = Math.floor((i_rgn_y - image_top) % this.tileSize[0]);
		if( grid_top > 0 || i_rgn_y > this.rgn_y  ) 
			{yoffset -= (i_rgn_y - this.rgn_y);}
		if( this.hei < this.rgn_h ) 
			{yoffset -= (this.rgn_h - this.hei)/2;}

	 	// Get the start tile numbers for our current image
	  var startx = Math.floor( (i_rgn_x - image_left) / this.tileSize[0] );
	 	var starty = Math.floor( (i_rgn_y - image_top) / this.tileSize[1] );
	
		// Get the end tile numbers for our current image
		if( grid_left > 0 || xoffset < 0) 
			{var i_rgn_w_o = i_rgn_w;}
		else
			{var i_rgn_w_o = i_rgn_w + xoffset;}

		if (i_rgn_w_o  % this.tileSize[0])
			{var endx =  Math.floor(i_rgn_w_o/this.tileSize[0]) + startx;}
		else
			{var endx =  Math.floor(i_rgn_w_o/this.tileSize[0]) + startx - 1;}

		if( grid_top > 0 || yoffset < 0) 
			{var i_rgn_h_o = i_rgn_h;}
		else
			{var i_rgn_h_o = i_rgn_h + yoffset;}

		if (i_rgn_h_o  % this.tileSize[1])
			{var endy =  Math.floor(i_rgn_h_o/this.tileSize[1]) + starty;}
		else
			{var endy =  Math.floor(i_rgn_h_o/this.tileSize[1]) + starty - 1;}

	  //The total number of tiles for the current image at 
		//this level of zoom
	  var xtiles = Math.ceil(image_wid / this.tileSize[0]);
   	var ytiles = Math.ceil(image_hei / this.tileSize[1]);
	
   	var tile, i, j, left, top, col, k = 0, r = 0;
////////		
//The exact value here depends on how the js var file has been prepared
				for( j=starty; j<=endy; j++ )
					{
			    for( i=startx; i<=endx; i++ )
						{
						r++;
						k = i + (j*xtiles);

						var src = cserver+'?'+im_fif+qua+"&cnt=1"+"&jtl="+
							cres+"," + k;
						
						//this.preLoad (src);
					
						if (this.tileSize[0] > image_wid)
							{var tim_wid = image_wid;}
						else if ( (i+1)*this.tileSize[0] > image_wid )
							{var tim_wid = image_wid % this.tileSize[0];}
						else
							{var tim_wid = this.tileSize[0];}
		
						if (this.tileSize[1] > image_hei)
							{var tim_hei = image_hei;}
						else if ( (j+1)*this.tileSize[1] > image_hei )
							{var tim_hei = image_hei % this.tileSize[1];}
						else
							{var tim_hei = this.tileSize[1];}

//Make sure that smaller images are always displayed as a larger /////
//thumbnail rather than a tiny image /////////////////////////////////
						var wid_min = Math.min (this.tileSize[0], this.grid_wid);
						var hei_min = Math.min (this.tileSize[1], this.grid_hei);
						
						//showDB("A Im("+wid_min+"x"+hei_min+")("+tim_wid+"x"+tim_hei+")")
						if ( j==starty && i==startx &&
							wid_min > tim_wid &&
							hei_min > tim_hei )
							{ 
							if (tim_wid > tim_hei)
								{
								twid = wid_min;
								thei = (wid_min/tim_wid) * tim_hei;

								if (thei > hei_min)
									{twid = (hei_min/tim_hei) * tim_wid;}

								var nm = twid - 10;
								xoffset = xoffset + (nm - tim_wid)/2;
								yoffset = yoffset + ((tim_hei * (nm/tim_wid)) - tim_hei)/2;
								tim_hei = tim_hei * (nm/tim_wid);			
								tim_wid = nm;
								}
							else
								{
								thei = hei_min;
								twid = (hei_min/tim_hei) * tim_wid;

								if (twid > wid_min)
									{thei = (wid_min/tim_wid) * tim_hei;}

								var nm = thei - 10;
								yoffset = yoffset + (nm - tim_hei)/2;
								xoffset = xoffset + ((tim_wid * (nm/tim_hei)) - tim_wid)/2;
								tim_wid = tim_wid * (nm/tim_hei);			
								tim_hei = nm;
								}

							//showDB("C Im("+tim_wid+"x"+tim_hei+")");
							}
////////////////////////////////////////////////////////////////////////////////

						var tim_left = (i-startx)*this.tileSize[0]- xoffset;
						var tim_top = (j-starty)*this.tileSize[1] - yoffset;

						this.insertTile (tim_left, tim_top, tim_wid, tim_hei, src, 
							'image', im_no);
						}
					}
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
				//add2DebugString ("nP: "+var_arr[13]);
				if (var_arr[13])
					{var bstyle = 'notPublic';}
				else
					{var bstyle = 'cover';}
					
				this.insertTile(grid_left, grid_top, this.grid_wid, this.grid_hei, 
					'blank', bstyle, im_no);
		}
	if (remainder && onGo)
//				{delayRun('iip.getImTiles()');}
				{iip.getImTiles();}
			else
				{crefresh = false;}
////////
		
		},
	
  loadTiles: function(){

  // Stop periodical our tile loaderer
  if( this.loader ){
    $clear( this.loader );
    this.loader = null;
    }

	this.loader = this.loadGrid.delay( 200, this );
  },

	getImTiles: function ()	{
	
	var var_arr = this.newTiles.pop();
	lastim = var_arr;
	remainder = this.newTiles.length;

	if (remainder == 0)
		{
		this.newTiles = this.newTiles_to;
		remainder = this.newTiles.length;
		this.newTiles_to = new Array();
		}

	//if (aj_to > 100)
	//	{this.loadTiles.delay( 100, this );}
	//else 
	if (var_arr)
		{
		var im_no = var_arr[0];
		var im_fif = var_arr[1];
		var check_path = this.server +'?'+ im_fif + 
		"&obj=IIP,1.0&obj=Max-size&obj=Tile-size&obj=Resolution-number";

		this.clearTargetNo(im_no);
		this.whichIms(var_arr);	

		$('loading').setOpacity(0);
		$('loading').style.zIndex = '-1';		
		$('target').style.cursor = 'move';		
		
		}
	},

  getNewTiles: function (gxo, gyo)
	{
	//showDB ('getNewTiles');
	if(sortby)
		{var pstr = "&sortby="+sortby;}
	else
		{var pstr = "&sortby=";}

	if ((this.end_gy - this.start_gy) == 0 && (this.end_gx - this.start_gx) == 0)
		{
		var h = this.start_gx + (this.start_gy * this.g_cols);
		var im_no = this.display_ims[h];
		} 
	var search_path = "ajax.php?what=tiles"+pstr+"&start_gx="+this.start_gx+
		"&start_gy="+this.start_gy+"&end_gx="+this.end_gx+"&end_gy="+this.end_gy+
		"&g_cols="+this.g_cols+"&no_ims="+this.no_ims+"&grid_max_x="+grid_max_x+
		"&grid_max_y="+grid_max_y+"&gxoffset="+gxo+"&gyoffset="+gyo+
		"&crop="+display_warning+"&sqllimit="+sqlLimit+
		"&whichdb="+whichDB+"&whichtable="+whichTable+"&newset="+this.newset+
		"";//field=;
		
	if (ow)
		{
    openWindow (search_path);
   }

	ims = "";	

	$('target').style.cursor = 'wait';
  $('loading').setOpacity(1);
  $('loading').style.zIndex = '2';
	var old = iip.newTiles;

	searchRequest = new Request( 
		{
		method: 'get',
		url: search_path,
		autoCancel: true, 
		async:false, 
    //data: { 'do' : '1' },  
    onRequest: function() {}, //alert('Request made. Please wait...'); 
		onFailure: function() {alert('FAILED')}, 
    onComplete: function(response) { 
			var checkResponse = /^(.new Array.+)/i.exec(response);
			var checkResponseb = /^([(][)].+)/i.exec(response);

			//showDB("searchComplete"); 

			if (doJump)
				{
				if (checkResponse || checkResponseb)
					{eval ('var nt = new Array '+ response);}

				doJump = false;
				jumpTo();
				}			
			else if (checkResponse || checkResponseb)
				{
				//alert (response);
				
				//add2DebugString (response);
  			eval ('var nt = new Array '+ response);
	
				iip.newTiles = nt;
				onGo = true;
				crefresh = true;
				iip.newTiles.reverse();

		
				var d = new Date();	
				previous = d.getTime();
				}
			else
				{/*alert (search_path + '\n\n' + response);*/}		

			iip.displayLink();
			}  
    });

	//showDB("searchRequest"); 
	searchRequest.send();  
	this.getImTiles();//.delay( 50, this );	
	},

	displayLink: function()	{

	var kw = "";
  var kw2 = "";
		
	if (keywords.length)
		{		
		for ( keyNo in keywords ) 
			{	
			if ( (typeof keywords[keyNo]) == 'object' && keywords[keyNo].length == 3) 
				{
				kw = kw + "%26keywords["+keyNo+"]="+ 
					"keywords.push([\'"+keywords[keyNo][0]+"\',\'"+keywords[keyNo][1]+
					"\',\'"+keywords[keyNo][2]+"\']);";
				kw2 = kw2 + "&keywords["+keyNo+"]="+ 
					"keywords.push(['"+keywords[keyNo][0]+"','"+keywords[keyNo][1]+
					"','"+keywords[keyNo][2]+"']);";
				}
			}
		}

	var path = getURL();
	linkHere = path+"?resolution="+this.resolution+
		"%26rgn_y="+this.rgn_y+"%26rgn_x="+this.rgn_x+
		"%26selected="+selected+"%26sortby="+sortby+"%26openControl="+openControl+kw;
	
  if ($('emailLink'))
  {
	$('emailLink').removeEvents();
	$('emailLink').addEvent('click',function(e){
		location.href ="mailto:?subject=Link to the National Gallery Collection Viewer&"+
			"body="+linkHere; 
		});	
	$('testA').href = path+"?resolution="+this.resolution+
		"&rgn_y="+this.rgn_y+"&rgn_x="+this.rgn_x+
		"&selected="+selected+"&sortby="+sortby+"&openControl="+openControl+kw2;}
	},

  /* Create a grid of tiles with the appropriate JTL request and positioning
   */
	loadGrid: function() {
		
		//showDB("loadGrid"); 
		this.clearTarget();//Clear old images
		this.gridVariables();//Refresh grid variables

		//To ensure viewer performance limit the number of images returned to the
		//Full number of tiles possible in the viewer.

		if (this.xscr_grids > (this.allow_xg) ||
				this.yscr_grids > (this.allow_yg))
			{
			var start_gx_os = this.start_gx + 
				Math.floor((this.xscr_grids - this.xscr_tiles)/2);
		 	var end_gx_os = this.end_gx - 
				Math.floor((this.xscr_grids - this.xscr_tiles)/2);
			var start_gy_os = this.start_gy + 
				Math.floor((this.yscr_grids - this.yscr_tiles)/2);
		 	var end_gy_os = this.end_gy - 
				Math.floor((this.yscr_grids - this.yscr_tiles)/2);
			}
		else
			{var start_gx_os = this.start_gx;
			 var end_gx_os = this.end_gx;
			 var start_gy_os = this.start_gy;
			 var end_gy_os = this.end_gy;}

 		// Calculate the offset from the tile top left that we want to display.
	  // Also Center the image if our viewable image is smaller than the window
	  var gxoffset = Math.floor(this.rgn_x % this.grid_wid);
  		if( this.wid < this.rgn_w ) gxoffset -=  (this.rgn_w - this.wid)/2;

  	var gyoffset = Math.floor(this.rgn_y % this.grid_hei);
    	if( this.hei < this.rgn_h ) gyoffset -= (this.rgn_h - this.hei)/2;

		//Insert background tile so functions will work on blank areas between images
	  var bgleft = 0;
			if ( this.wid < this.rgn_w ) bgleft -= gxoffset;
		var bgtop = 0;
			if ( this.hei < this.rgn_h ) bgtop -= gyoffset;

	  var abgleft = 0 - this.rgn_x;
			if ( this.wid < this.rgn_w ) abgleft -= gxoffset;
		var abgtop = 0 - this.rgn_y;
			if ( this.hei < this.rgn_h ) abgtop -= gyoffset;
	
		//if the edge of the grid should be visible then show it
		if (this.rgn_w < 3 * this.wid || this.rgn_h < 3 * this.hei)  
			{
			this.insertTile( abgleft, abgtop, (this.wid - 10), (this.hei - 10), 
				'blank', 'bground');
			}
		else
			{
			this.insertTile( bgleft, bgtop, this.wid, this.hei, 'blank', 'bground');
			}
	
    // Create our image tile mosaic
		this.getNewTiles (gxoffset, gyoffset);
		},

  insertTile: function(left, top, wid, hei, src, which, im_no) {
		
		var uid = 'tile_'+im_no+'_'+left+'_'+top;
		
		if (src == 'blank')
			{tsrc = images+'transparentpixel.gif';}
		else
			{
			if (stop_browser_cache)
				{var now = new Date();
				var tsrc = src + '&' + now.getTime();}
			else
				{var tsrc = src;}
				
				tsrc = fifPrep (tsrc);
			}
			
    // This avoids smaller images being blown up and images apearing pixelated
    if( ims = /^(.+QLT=[0-9]+[&]cnt=[0-9]+[&])jtl=0,0/i.exec(tsrc) )
      {tsrc = ims[1]+'WID='+(wid*1.5)+'&CVT=JPEG';}
      
		if (im_no || im_no == 0)
			{
			if (which == 'missing')
				{}
			}

	if (which == 'missing')
		{var border = '1px solid red';}
	else if (which == 'temp')
		{var border = '1px solid #333333';} 
	else if (which == 'blank')
		{var border = '1px solid white';}
	else if (which == 'notPublic')
		{		
		if (im_no == selected)
			{var border = '2px solid orange';} 
		else
			{var border = '1px solid red';} 
		} 
	else if (which == 'cover')
		{
		if (im_no == selected)
			{var border = '2px solid yellow';} 
		else
			{var border = 'none';} 
		}
	else
		{var border = 'none';} 

	var uid = 'tile_'+im_no+'_'+left+'_'+top;

	var tile = new Element('img', {
		'id': uid,
		'src': tsrc, 
		'styles': 
			{
    	'position': "absolute",
			'width':  wid+'px',
			'height': hei+'px',
			'left': 	left,
			'top': top,
			'filter': 'alpha(opacity=20)',
		  'opacity': 1,
			'border': border
    	},
		'events':
			{
			'mousedown': this.selectImage.bindWithEvent(this),
			'mouseover':function(){}
			},
		'class': which, 
		'alt': im_no
		});
  		
	tile.injectInside('target');		
	},

  preLoad: function(tsrc)
		{
		var preim = new Image();
		preim.src = tsrc;
		},

	swapSrc: function(id, tsrc)
		{$(id).src = tsrc;},

  /* Refresh function to avoid the problem of tiles not loading
     properly in Firefox/Mozilla
   */
  refresh: function(){

		//showDB ("##### REFRESH ######");
    var t_unloaded = 0;
		var missing = "Missing Images";

    $('target').getChildren().each( function(el){
      // If our tile has not yet been loaded, give it a prod ;-)
      if( el.width == 0 || el.height == 0 || el.complete == false){
				missing = missing + "\n" + el.src;
				el.src = el.src;
				t_unloaded++;
      }
    });

		if (remainder || crefresh)
			{t_unloaded++;}

		if(t_unloaded)
			{unloaded++;}

    /* If no tiles are missing, destroy our refresher timer, fade out our loading
       animation and and reset our cursor
     */
    if( t_unloaded == 0 ){
      $clear( this.refresher );
      this.refresher = null;
			
      // Fade out our loading animation
/*
      var f = $('loading').effect('opacity', {
				duration: 750,
				frames: 10,
				transition: Fx.Transitions.quadOut,
				onComplete: function(){
				  $('loading').style.zIndex = '-1';
					}
      });

      f.start(1,0);*/
      $('target').style.cursor = 'move';
    }
  },


  /* Allow us to navigate within the image via the keyboard arrow buttons
   */
  key: function(e){
    var d = 100;
    switch( e.keyCode ){
    case 37: // left
      this.scrollTo(-d,0);
      break;
    case 38: // up
      this.scrollTo(0,-d);
      break;
    case 39: // right
      this.scrollTo(d,0);
      break;
    case 40: // down
      this.scrollTo(0,d);
      break;
    case 107: // plus
      if(!e.ctrlKey) this.zoomIn();
      break;
    case 109: // minus
      if(!e.ctrlKey) this.zoomOut();
      break;
    }
  },



  /* Scroll resulting from a drag of the navigation window
   */
  scrollNavigation: function( e ) {
		//showDB('scrollNavigation');
    var xmove = 0;
    var ymove = 0;

    var zone_size = $("zone").getSize();
    var zone_w = zone_size.x;
    var zone_h = zone_size.y;

    if( e.event ){
      // From a mouse click
      var pos = $("navwin").getPosition();
      xmove = e.event.clientX - pos.x - zone_w/2;
      ymove = e.event.clientY - pos.y - zone_h/2;
    }
    else{
      // From a drag
      xmove = e.offsetLeft;
      ymove = e.offsetTop;
      if( (Math.abs(xmove-this.navpos[0]) < 3) && (Math.abs(ymove-this.navpos[1]) < 3) ) return;
    }

    if( xmove > (this.nav_x - zone_w) ) xmove = this.nav_x - zone_w;
    if( ymove > (this.nav_y - zone_h) ) ymove = this.nav_y - zone_h;
    if( xmove < 0 ) xmove = 0;
    if( ymove < 0 ) ymove = 0;

    this.rgn_x = xmove * this.wid / this.nav_x;
    this.rgn_y = ymove * this.hei / this.nav_y;

    this.requestImages();
    if( e.event ) this.positionZone();
  },

  

  scrollToGrid: function() {

		if (sel_col >=0 && sel_row >= 0)
			{
			var cgx = (this.x_s * sel_col) + (this.x_s/2);
			var cgy = (this.y_s * sel_row) + (this.y_s/2);

			var cratio = this.wid/this.max_width;
	
			var cgridw = grid_max_x * cratio;
			var cgridh = grid_max_y * cratio;

			var tx = cgridw;
	    var ty = cgridh;

			var intimes = 0;
			var outtimes = 0;
			
			if (tx < this.rgn_w || ty < this.rgn_h)
    		{
		    while( tx < this.rgn_w ){
  		    tx = parseInt(tx * 2);
    		  ty = parseInt(ty * 2);
					intimes++;
			    }
  		  while( ty < this.rgn_h ){
  	  	  tx = parseInt(tx * 2);
	      	ty = parseInt(ty * 2);
					intimes++;
	  		  }

				for( j=0; j<intimes; j++ )
					{this.zoomIn_prep();}
				}
			else
				{
		    while( tx > this.rgn_w ){
  		    tx = parseInt(tx / 2);
    		  ty = parseInt(ty / 2);
					outtimes++;
		    }
  		  while( ty > this.rgn_h ){
    		  tx = parseInt(tx / 2);
      		ty = parseInt(ty / 2);
					outtimes++;
	  	  }
			
				outtimes--;

				//alert ('ZoomOut x '+ outtimes);
				for( j=0; j<outtimes; j++ )
					{this.zoomOut_prep();}
				}

			var sgx = cgx * (this.wid/this.max_width);
			var sgy = cgy * (this.hei/this.max_height);

	    var xmove = (sgx - (this.rgn_w/2)) - this.rgn_x;
  	  var ymove = (sgy - (this.rgn_h/2)) - this.rgn_y;

			this.scrollTo( xmove, ymove );
			}
		else
			{}
  },



  /* Scroll from a target drag event
   */
  scroll: function() {
    var xmove =  - $('target').offsetLeft;
    var ymove =  - $('target').offsetTop;
    this.scrollTo( xmove, ymove );
  },



  /* Scroll to a particular position
   */
  scrollTo: function( x, y ) {
		
		//showDB('scrollTo');

    if( x || y ){

      // To avoid unnecessary redrawing ...
      if( (Math.abs(x) < 3) && (Math.abs(y) < 3) ) return;

      this.rgn_x += x;
      this.rgn_y += y;

      if( this.rgn_x > this.wid - this.rgn_w ) this.rgn_x = this.wid - this.rgn_w;
      if( this.rgn_y > this.hei - this.rgn_h ) this.rgn_y = this.hei - this.rgn_h;
      if( this.rgn_x < 0 ) this.rgn_x = 0;
      if( this.rgn_y < 0 ) this.rgn_y = 0;

      this.requestImages();
      this.positionZone();

    }
  },



  /* Generic zoom function
   */
  zoom: function( e ) {

    var event = new Event(e);

		//It would be good to be able to centre zooms on the mouse pointer 
		//with the scroll wheel  as well but I have not found the rght x&y 
		//coordinates yet.
		var tp = $(this.source).getPosition();
    var xmove = 0;
    var ymove = 0;

    xmove = event.event.clientX - this.rgn_w/2 - tp.x;
    ymove = event.event.clientY - this.rgn_h/2 - tp.y;
    
		var cwid = this.wid;
	
		 if( event.wheel > 0 ) this.zoomIn_prep();
      else if( event.wheel < 0 ) this.zoomOut_prep();
			// For double clicks
    	else if(event.shift) {
				this.zoomOut_prep();
  		  }
	    else{
				this.zoomIn_prep();
				}

			var mp = this.wid/cwid;
			this.scrollTo( xmove*mp, ymove*mp );
  },

	/* Generic zoom function
   */
  zoomSlider: function( pos ) {

	var old_wid = this.wid;

	if (this.resolution > pos)
		{
		var dif = this.resolution - pos;
		for( j=0; j<dif; j++ )
			{this.zoomOut_prep();}
		}
	else if (this.resolution < pos)
		{
		var dif = pos - this.resolution;
		for( j=0; j<dif; j++ )
			{this.zoomIn_prep();}
		}
	else {}

	if (old_wid != this.wid)
		{this.requestImages();
     this.positionZone();}
  },


  /* Zoom in by a factor of 2
   */
  zoomIn_prep: function ()
		{
		var go = true;

		if( (this.wid > (this.max_width/2)) && (this.hei > (this.max_height/2)) )
				{go = false;}

		if( (this.wid > (resolution_limit/2)) || (this.hei > (resolution_limit/2)) )
				{go = false;}

		if (go)
			{
      this.wid = this.wid * 2;
      this.hei = this.hei * 2;

      if( this.xfit == 1 )
				{this.rgn_x = this.wid/2 - (this.rgn_w/2);}
      else if( this.wid > this.rgn_w ) 
				{this.rgn_x = 2*this.rgn_x + this.rgn_w/2;}

      if( this.rgn_x > this.wid ) this.rgn_x = this.wid - this.rgn_w;
      if( this.rgn_x < 0 ) this.rgn_x = 0;

      if( this.yfit == 1 )
				{this.rgn_y = this.hei/2 - (this.rgn_h/2);}
      else if( this.hei > this.rgn_h ) 
				{this.rgn_y = this.rgn_y*2 + this.rgn_h/2;}

      if( this.rgn_y > this.hei ) this.rgn_y = this.hei - this.rgn_h;
      if( this.rgn_y < 0 ) this.rgn_y = 0;

      this.resolution++;
    	}

		if (slider.step != this.resolution && slider)
			{slider.step= this.resolution;
			 slider.fireEvent('tick', slider.toPosition(this.resolution));}
 	},


  /* Zoom in by a factor of 2
   */
  zoomIn: function (){
		//showDB('zoomIn');
		var old_wid = this.wid;
		this.zoomIn_prep();    

		if (old_wid != this.wid)
			{
	    this.requestImages();
  	  this.positionZone();
			}
  },



  /* Zoom out by a factor of 2
   */
  zoomOut_prep: function(){
		
		//Refresh grid variables, limits how far you can zoom out
		this.gridVariables();

		if (this.resolution >= 1)
			{
      this.wid = this.wid / 2;
      this.hei = this.hei / 2;

      this.rgn_x = this.rgn_x/2 - (this.rgn_w/4);
      
			if( this.rgn_x + this.rgn_w > this.wid ) 
				{this.rgn_x = this.wid - this.rgn_w;}
      
			if( this.rgn_x < 0 )
				{
				this.xfit=1;
				this.rgn_x = 0;
		    }
      else this.xfit = 0;

      this.rgn_y = this.rgn_y/2 - (this.rgn_h/4);
     
			if( this.rgn_y + this.rgn_h > this.hei ) 
				{this.rgn_y = this.hei - this.rgn_h;}
      
			if( this.rgn_y < 0 )
				{
				this.yfit=1;
				this.rgn_y = 0;
      	}
      else this.yfit = 0;

      this.resolution--;
    }

		if (slider.step != this.resolution && slider)
			{slider.step= this.resolution;
			 slider.fireEvent('tick', slider.toPosition(this.resolution));}
  },


  /* Zoom out by a factor of 2
   */
  zoomOut: function(){
		//showDB('zoomOut');
		var old_wid = this.wid;
		this.zoomOut_prep();   

		if (old_wid != this.wid)
			{
    	this.requestImages();
	    this.positionZone();
			}
  },


  /* Calculate some dimensions
   */
  calculateMinSizes: function(){

    var tx = this.max_width;
    var ty = this.max_height;
    var thumb = 100;

    var winWidth = $(this.source).getWidth();//Window.getWidth();
    var winHeight = $(this.source).getHeight();//Window.getHeight();

    if( winWidth>winHeight ){
	    // For panoramic images, use a large navigation window
	    if( tx > 2*ty ) thumb = winWidth / 2;
	    else thumb = winWidth / 4;
      }
    else thumb = winHeight / 4;

	if(thumb > 50)
		{thumb = 50;}		
	
    var r = this.resolution;
    while( tx > thumb ){
      tx = parseInt(tx / 2);
      ty = parseInt(ty / 2);
      // Make sure we don't set our navigation image too small!
	  // Small navigation images are needed for larger sets of images
      //if( --r == 1 ) break;
    }
    while( ty > thumb ){
      tx = parseInt(tx / 2);
      ty = parseInt(ty / 2);
      // Make sure we don't set our navigation image too small!
	  // Small navigation images are needed for larger sets of images
      //if( --r == 1 ) break;
    }
    this.min_x = tx;
    this.min_y = ty;
    this.min_x_s = tx/this.g_cols;
    this.min_y_s = ty/this.g_rows;
    
    //Make navwindow smaller on small screens, this needs to be redone
    //So it is dynamic.  Do when upgrading to new version of IIP
    var winD = Window.getSize();
	  var winW = winD.x;
	  var winH = winD.y;
	
	  var xm, ym;
	  
	  if (winW < 1025)
	    {xm = 110;
		   ym = 65;}
    else if (winW < 1281)
	    {xm = 160;
		   ym = 94.5;}
    else 
      {xm = 220;
		   ym = 130;}
		   		
    var xf = xm/tx;
		var yf = ym/ty;
		
		if ((xf * ty) > ym)
			{this.nav_x = yf * tx;
			 this.nav_y = ym;}
		else
			{this.nav_x = xm;
			 this.nav_y = xf * ty;}

    // Determine the resolution for this image view
    tx = this.max_width;
    ty = this.max_height;
    while( tx > winWidth && ty > winHeight ){
      tx = parseInt(tx / 2);
      ty = parseInt(ty / 2);
      this.resolution--;
    }
    this.wid = tx;
    this.hei = ty;
    this.resolution--;
  },

	/* Create our main and navigation windows
   */
  createWindows: function(){
  add2FunctionString ("CreateWindows");

	// Get our window size - subtract some pixels to make sure the browser never
  // adds scrollbars
	var s = $(this.source).getSize();
	var p = $(this.source).getPosition();

  var winWidth = s.x;
  var winHeight = s.y;

  // Create our loading animated icon
  var loading = new Element('img',
  	{
  	'styles': {
    	'left': (s.x/2) + 'px',
      'top':  (s.y/2) + 'px'
    	},
    'id': 'loading',
    'src': images+'loading.gif'
    });
	loading.injectInside( this.source );

  // Calculate some sizes and create the navigation window
  this.calculateMinSizes();

	this.createNavigationWindow();
		
  // Create our main window target div, add our events and inject inside the frame
  var el = new Element('div', {'id': 'target'} );
  el.injectInside( this.source );
  var cap = new Element('div', {'id': 'captions'} );
  cap.injectInside( this.source );

	el.removeEvents();

  var thisDrag = new TargetDrag( el, {    
		onComplete: this.scroll.bind(this)
    } ); 

  el.addEvent('mousewheel', this.zoom.bind(this) );
  el.addEvent('dblclick', this.zoom.bind(this) );  

  this.rgn_w = winWidth;
  this.rgn_h = winHeight;
	
	//showDB('createWindows');
	//Additional extra stuff, requires extra functions
	createControls();
		
	
	//Refresh grid variables, limits how far you can zoom
	this.gridVariables();

	var x_no = Math.ceil((this.xscr_grids/this.allow_xg)/2);
	var y_no = Math.ceil((this.yscr_grids/this.allow_yg)/2);

	if (x_no > y_no)
		{var ntimes = x_no - 1;}
	else
		{var ntimes = y_no - 1;}

	for( j=0; j<ntimes; j++ )
		{this.zoomIn_prep();}

	this.zoomIn_prep();
	this.zoomOut_prep(); 

	this.reCenter();

	this.newset = true;
	
	// Add our logo and a tooltip explaining how to use the viewer
    new Element( 'a', {href: 'http://iipimage.sourceforge.net', 'class':'logo', 'id':this.source+'_logo'} ).injectInside(this.source);
    new Element('img', {src: 'graphics/help.png', 'class':'info', 'id': this.source+'_info', styles: { opacity: 0.8 } } ).injectInside(this.source+'_logo');

    // Fix IE7 PNG transparency problem
    if( Browser.Engine.trident5 ){
      $(this.source+'_info').setStyle( 'filter', 'progid:DXImageTransform.Microsoft.AlphaImageLoader(enabled=true,src="images/iip.32x32.png",sizingMethod=scale)' );
    }

    new Tips( '#'+this.source+'_info, #'+this.source+'_toolbar', {
	  className: 'tip', // We need this to force the tip in front of nav window
	  // We have to first set opacity to zero to fix a bug in mootools 1.2
	  // where the tip appears without any fade in the first time it is loaded
	  onShow: function(t){ t.setStyle('opacity',0); t.fade(0.7); },
	  onHide: function(t){ t.fade(0); }
    });
		
    $(this.source+'_info').store('tip:text', '<h3>IIP Image Viewer</h3>'+
			'<ul><li>To move images around:<ul>'+
			'<li>drag image within main window or</li>'+
			'<li>drag light grey rectangle within grey box in the top right corner</li>'+
			'</ul><li>To zoom in:'+
			'<ul><li>double click with the mouse or</li><li>use the mouse scroll wheel or</li>'+
			'<li>or simply press the "+" key</li></ul><li>To zoom out:<ul><li>'+
			'shift double click with the mouse or</li><li>use the mouse wheel or</li>'+
			'<li>press the "-" key</li></ul></li></ul>');
    
    if (this.hideIcon)
      {$(this.source+'_logo').setStyle('display', 'none');} 
	
	// Add some info
    if( this.help ){
      new Element( 'div', {'class': 'help', 'id': this.source+'_help', html: this.help} ).injectInside(this.source);
    }

	//These do not seem to be needed really need to track down how this works again ;-)
	this.requestImages();
	this.positionZone();
  },

	selectImage: function (e)
		{
		if (!e) var e = window.event;
		clearCover();
		
		if (e.target.alt || e.target.alt == 0)
			{
			var imno=e.target.alt;
			if ( e.target.className == "cover")
				{e.target.style.border = '2px solid yellow';}
			else if ( e.target.className == "notPublic")
				{e.target.style.border = '2px solid orange';}
			}
		else if(e.srcElement.alt)
			{
			var imno=e.srcElement.alt;
			if (e.srcElement.className == "cover")
				{e.srcElement.style.border = '2px solid yellow';}
			else if ( e.target.className == "notPublic")
				{e.target.style.border = '2px solid orange';}
			}
		else{imno = null;}//old browsers		

		selected = imno;
		this.displayLink();
		updateObjectMenu (imno);
		},


  /* Create our navigation window
   */
  createNavigationWindow: function() {
    
    // Create our navigation div and inject it inside our frame
    var navwin = new Element( 'div', {
      id: 'navwin',
      styles: {
				width: this.nav_x + 'px',
				height: this.nav_y + 'px'
      }
    });
    //navwin.injectInside( $('Explore') );
    navwin.injectInside( this.source );

	// Create our navigation image and inject inside the div we just created
    var navimage = new Element( 'img', { id: 'navigation' } ).setStyles({
			opacity: 0.8,
      width: this.nav_x + "px",
     	height: this.nav_y +"px"}).injectInside( navwin );

    // Create our navigation zone and inject inside the navigation div
    var zone = new Element( 'div', {
      id: 'zone',
      styles: {
			width: this.nav_x/2 + 'px',
			height: this.nav_y/2 + 'px',
			opacity: 0.4}});

    zone.injectInside( navwin );
		
		$('navigation').removeEvents();		
		$('zone').removeEvents();

    $("zone").makeDraggable({
    	container: 'navwin',
			// Take a note of the starting coords of our drag zone
			onStart: function(){
			  this.navpos = [$('zone').offsetLeft, $('zone').offsetTop];
				}.bind(this),
			onComplete: this.scrollNavigation.bind(this)
    });
    
		$("navigation").src = images+'transparentpixel.gif';

    // Add our events
    $("navigation").addEvent('click', this.scrollNavigation.bindWithEvent(this) );
    $('navigation').addEvent('mousewheel', this.zoom.bindWithEvent(this) );

    $('zone').addEvent('mousewheel', function(event) {this.zoom;})
    $("zone").addEvent( 'dblclick', function(event) {this.zoom;})
    
    //navwin.injectInside( $('Explore') );
    navwin.injectInside( this.source );

  },

  /* Use a AJAX request to get the image size, tile size and number of resolutions from the server
   */
  load: function(){
	
		this.max_width = parseInt(grid_width);
		this.max_height = parseInt(grid_height);

		this.tileSize[0] = parseInt( tile_size );
		this.tileSize[1] = parseInt( tile_size );
		this.resolution = parseInt(max_res);

		this.createWindows();
  },


  /* Recenter the image view
   */
  reCenter: function(){

		if (start_point == 1)
			{
  	  this.rgn_x = 0;
	    this.rgn_y = 0;
			}
		else
			{
	    this.rgn_x = (this.wid-this.rgn_w)/2;
  	  this.rgn_y = (this.hei-this.rgn_h)/2;

			if( this.rgn_x < 0 ) this.rgn_x = 0;
			if( this.rgn_y < 0 ) this.rgn_y = 0;
			}
  },



  /* Reposition the navigation rectangle on the overview image
   */
  positionZone: function(){

    var pleft = (this.rgn_x/this.wid) * (this.nav_x);
    if( pleft > this.nav_x ) pleft = this.nav_x;
    if( pleft < 0 ) pleft = 0;

    var ptop = (this.rgn_y/this.hei) * (this.nav_y);
    if( ptop > this.nav_y ) ptop = this.nav_y;
    if( ptop < 0 ) ptop = 0;

    var width = (this.rgn_w/this.wid) * (this.nav_x);
    if( pleft+width > this.nav_x ) width = this.nav_x - pleft;

    var height = (this.rgn_h/this.hei) * (this.nav_y);
    if( height+ptop > this.nav_y ) height = this.nav_y - ptop;

    if( width < this.nav_x ) this.xfit = 0;
    else this.xfit = 1;
    if( height < this.nav_y ) this.yfit = 0;
    else this.yfit = 1;

		if ($('zone'))
			{
	    var border = $("zone").offsetHeight - $("zone").clientHeight;

			$('zone').setStyles({
  	  	'left': pleft - border/2,
  	  	'top': ptop - border/2,
  	  	'width': width,
  	  	'height': height
				});
			}
  },

	//This function does not yet work as the server needs to be upgraded
	/*changeContrast: function(e)
		{
		if (!e) var e = window.event;
	
		var imid;		

		if (e.target.id)
			{imid=e.target.id;}
		else if(e.srcElement.id)
			{imid=e.srcElement.id;}
		else{imid = null;}

		if (selected >= 0)
			{
			if (im_con_base[selected] == 1)
				{var adj = 0.1;
				 var fix = 1;}
			else
				{var adj = 0.001;
				 var fix = 3;}
		
			var con_current = myData[selected]['im_con_current'];

			if (imid == 'con_up')
				{con_current = parseFloat(con_current-(-adj));}
			else if (imid == 'con_dn')
				{con_current = parseFloat(con_current-adj);}
			else 
				{con_current = myData[selected]['im_con_base'];}

			myData[selected]['im_con_current'] = con_current.toFixed(fix);
	
	  	this.requestImages();
  	  this.positionZone();

			}
		else
			{
			
			}
		},*/

	refreshWindows: function(){

	//alert ('refresh you idiot :-)');
	//var ow = this.rgn_w;
	//var oh = this.rgn_h;

	var s = $(this.source).getSize();
	var p = $(this.source).getPosition();

	//var wd = ow - s.x;
	//var hd = oh - s.y;

  this.rgn_w = s.x;
  this.rgn_h = s.y;

  $('loading').style.left = (s.x/2) - 16  + 'px';
  $('loading').style.top = (s.y/2) - 16 + 'px';
  updateObjectMenu (selected);
	this.requestImages();
	this.positionZone();
  },

	limitGroup: function(){
    // Delete our old targetframe
	  this.no_ims = this.display_ims.length;
		this.g_cols = Math.ceil(Math.pow(this.no_ims,0.5));;
		this.g_rows = Math.ceil(this.no_ims/this.g_cols);

		this.max_width = this.g_cols*grid_max_x;
		this.max_height = this.g_rows*grid_max_y;
		this.resolution = parseInt(max_res);
	
		this.refreshWindows();
		}, 

	DisplayAll: function(){
		this.display_ims = all_ims;
		this.keywords = new Array();
		this.limitGroup();
		}	
});


/*
Request = Request.extend({
    request: function(){
    if (this.options.timeout) {
        this.timeoutTimer=window.setTimeout(
				this.callTimeout, this.options.timeout
				);
        this.addEvent('onComplete', this.removeTimer);
    }
    this.parent();
    },

    callTimeout: function () {
        this.transport.abort();
        //this.onFailure();
        if (this.options.onTimeout) {
            this.options.onTimeout();
        }
    },

    removeTimer: function() {
        window.clearTimeout(this.timeoutTimer);
    }
});*/

function openWindow ( t_href, t_html, debg)
	{
	if (debg)
		{winRef = window.open( t_href+'&debug=1', t_html);}
	else
		{winRef = window.open( t_href, t_html);}
	}


function posSlider (cls, sno)
	{
	$$('div.slider.advanced').each(function(el, i){
		slider = new Slider(el, el.getElement('.knob'), {
			id: 'fred',
			snap: false,
			mode: 'horizontal',
			steps: (cls.max_res-1),  // Steps from 0 to 9
			wheel: true, // Using the mousewheel is possible too
			onChange: function(){}, 
			onComplete: function(){
				iip.zoomSlider(this.step);
			}
		}).set(0);
	});

	}

function posDivider (eA, eB, sL, dir)
	{
	var seA = eA.getSize();
	var seB = eB.getSize();
	var peA = eA.getPosition();
	var peB = eB.getPosition();

	if (dir == 'vertical')
		{
		sL.style.height = (seT.y + seB.y) + 'px';
		sL.style.top = (peT.y) +'px';
		sL.style.left = (peT.x - 8) + 'px'; //8 pixels being 
		}
	else
		{
		dir = 'horizontal';
		}

	sL.style.height = (seT.y + seB.y) + 'px';
	sL.style.top = (peT.y) +'px';
	sL.style.left = (peT.x - 8) + 'px';

	$$('div.slider.advanced').each(function(el, i){
		var slider = new Slider(el, el.getElement('.knob'), {
			mode: dir,
			steps: 10,  // Steps from 0 to 9
			wheel: true, // Using the mousewheel is possible too
			onChange: function(){
				stuff (eT, eB, ((this.step)/10), (seT.y + seB.y - 12), peT.y );
			}, 
			onComplete: function(){
				stuff (eT, eB, ((this.step)/10), (seT.y + seB.y - 12), peT.y );
			},
			snap: true
		}).set(1);
	});

	}

function initEvents ()
	{
	$('openClose').addEvent('click', function(event){
		openClose ($('MainPanel'), $('SidePanel'), oW);
		});
	$('ZoomIn').addEvent('click', function(event){
		var npos = slider.step + 1;

		if (npos <= slider.steps)
			{slider.step = npos;
			 slider.fireEvent('tick', slider.toPosition(npos));
			 slider.fireEvent('onComplete');}
		});
	$('ZoomOut').addEvent('click', function(event){
		var npos = slider.step - 1;

		if (npos >= 0)
			{slider.step = npos;
			 slider.fireEvent('tick', slider.toPosition(npos));
			 slider.fireEvent('onComplete');}
		});

	$('keywordSearch').addEvent('submit', function(event){
			checkKeywords($('limitBy').value, $('keysearch').value, 0, 1, 0);
			getSearchResults ();
			$('keysearch').value = 'enter value';
			return false;});

	$('imOrder').addEvent('submit', function(event){
		return false;});
	}


		
function fifPrep (fif)
  {
  fif = fif.replace("%27", "@@@@@");
  fif = fif.replace("'", "£££££");
  
  return (fif);
  }
		
function stuff (eT, eB, ratio, max, top)
	{
	var ps = eT.getPosition();
	var pk = $('knob').getPosition();
	var pr = $('red').getPosition();

	var myT = new Fx.Tween(eT);
	var myB = new Fx.Tween(eB);

	var hT = (ratio * max) - 5;

	var hB = max - hT - 15;
	if (hB < 0) 
		{hB = 0;
		 myB.set('display', 'none');}
	else {myB.set('display', 'block');}
	var tB = ps.x + hT;

	myT.set('height', hT+'px');
	myB.set('height', hB + 'px');
	myB.set('top', (ps.y + hT + 12) + 'px');

	iip.refreshWindows();	
	}

/*
function basicRefresh () {	
	$('viewer').style.display = 'none';
  winD = Window.getSize();
	winW = winD.x, winH = winD.y;
	var ofst = 0; 
	var expH = 199; 
	var zooH = 64; 
	var disH = 57;

	if (winW < 1024)
		{winW = 1024;}

	if (winH < 395)
		{winH = 400;
		 winW = winW - 20;}

	oW = spWidth - pgBorder - (2*pnBorder);

	$('title').style.width = winW - 200 - 30 + 'px';
	$('MainPanel').style.top = bnHeight + 'px';
	$('MainPanel').style.left = pgBorder + 'px';
	$('MainPanel').style.height = (winH - bnHeight - pgBorder - (2*pnBorder)) + 'px';
	$('MainPanel').style.width = (winW - spWidth) - 8 + 'px';

	$('SidePanel').style.height = (winH - bnHeight - pgBorder - (2*pnBorder)) + 'px';
	$('SidePanel').style.width = spWidth - pgBorder - (2*pnBorder) + 'px';
	$('SidePanel').style.left = (winW - spWidth) + 'px';
	$('SidePanel').style.top = bnHeight + 'px';

	var spbottom = winH - pgBorder - (2*pnBorder);

	var selDet = getElementsByClassName("Details", "div", $('SidePanel'));
	var th = (winH - bnHeight - pgBorder - (4*pnBorder) - 424 - (3*dtSpacer));

	if (Browser.Engine.name == "trident")
		{var adj = 17;}
	else if (Browser.Engine.name == "webkit")
		{var adj = 17;}
	else
		{var adj = 15;}

	for(var i=0; i<selDet.length; i++) 
		{selDet[i].style.width = spWidth - pgBorder - (2*pnBorder) - (2*dtSpacer) - ofst - adj + 'px';}

	var selDet = getElementsByClassName("DetailsTable", "table", $('SidePanel'));
	for(var i=0; i<selDet.length; i++) 
		{selDet[i].style.width = '100%';}
	
	$('viewer').style.display = 'block';
	positionOC (winW - spWidth);	

	var whbottom = $('whites').offsetHeight + $('whites').offsetTop;

	if (whbottom > spbottom)
		{$('whitespacer').style.height = '5 px';}
	}

if (typeof (updateObjectMenu) == 'undefined') 
	{eval ("function updateObjectMenu (id)	"+
		+"{showDB('updateObjectMenu BLANK B');}");}

*/
