/*
  Raphael Research Resource Text display Javascript Viewer 
	 	<http://cima.ng-london.org.uk/documentation>
  
	                    Version 1.0

  Copyright (c) 2009 Joseph Padfield <joseph.padfield@ng-london.org.uk>

  Built using the Mootools 1.2 javascript framework <http://www.mootools.net>

   ---------------------------------------------------------------------------

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   ---------------------------------------------------------------------------


  Example:

   newTxt = new rrrTxt( 'parent_div_id', { 
		 options ....
		   } );

*/

/*
 * TODO: This is far from complete and needs to be finished off.
 * 
 * 1: Document clear purpose.
 * 	Intention to produce a list of text titles
 * 		which become multi (n) level accordion on selection.
 * 	Option to display further details on selection.
 * 	Option for additional events; linking, editing, etc.
 * 2: Clean up and complete Class, remove reliance on external functions
 * 3: Correct CSS/style of produced accordion.
 * 4: Catch and display html links in the texts correctly.
 * 5: ??? Editing and creation of new texts/sections in this form
 * 6: ??? Reordering texts, can it be drag and drop type stuff ??
 * 
 */
 
//This class can me made to change other values depending on the 
//selected text through the externalFunction
if (typeof externalFunction != "function") {
//if (!window.externalFunction){
	eval ("function externalFunction(detailsPrefix, which, selected, edit)"+
	 "{add2DebugString(\"RUN externalFunction ngdd_displaytexts.js\");}");}

/* IIP Javascript Class
 */
var rrrTxt = new Class({
	
   /* Initialize some variables. 
   */
    initialize: function( main_id, options ) {

		//Convert all options to class variables.
    this.source = main_id || alert( 'No element ID given to IIP constructor' );
		this.search_vars = options['searchSQL'] || {"which":"text","searchObject":{},"searchCategory":{},"searchDetail":{}};
		this.furtherdetails = options['furtherdetails'] || null;
		this.furtherdetailsEdit = options['furtherdetailsEdit'] || null;
		this.limittitlelength = options['limittitlelength'] || null;
		this.externalVars = options['externalVars'] || null;		
		this.top = options['topoffset'] || 0;
		
		if (!this.furtherdetailsEdit)
			{this.externalVars = null;}

    //Initiate all other required global class variables  
		this.size = $(this.source).getSize();
		this.width = this.size.x;
		//used to limit the length of the titles in the basic list
		this.wlimit = this.width/7.5;
		this.acc;
		this.active = 0;
		
		this.height = this.size.y;
		
		if (this.furtherdetails)
			{this.height = this.height - 161;}
		if (this.externalVars)
			{this.height = this.height - 65;}
		
    /* Load us up when the DOM is fully loaded! 
     */
    window.addEvent( 'domready', function(){  this.load() }.bind(this) );
  },

  /* Use a AJAX request to get the text details
   */
  load: function(vars){    
    
		removeChildrenFromNode($(this.source));
		
		var contDiv = new Element("div", {
    'class': 'accContainer',
		'id': this.source + '_cont'});
		$(this.source).appendChild(contDiv); 
		contDiv.setStyles({'height': this.height + 'px', 'top': this.top +'px', 'left': '0px'});
		
		var listDiv = new Element("div", {
    'class': 'accContainerSub',
		'id': this.source + '_list'});
		$(contDiv).appendChild(listDiv); 
		listDiv.setStyles({'height': this.height - 6  + 'px', 'top': '0px', 'left': '0px'});
		
		if (this.furtherdetails)
			{var fdDiv = new Element("div", {
    	'class': 'pageframe',
			'id': this.source+'_furtherDetails'});
			$(this.source).appendChild(fdDiv); 
			fdDiv.setStyles({'height': '154px', 'top': this.top + this.height + 2 + 'px', 'left': '0px'});}
			
		if (this.externalVars)
			{var linkDiv = new Element("div", {
    	'class': 'pageframe',
			'id': this.source+'_link'});
			$(this.source).appendChild(linkDiv); 
			linkDiv.setStyles({'height': '65px', 'top': this.top + this.height + 155 + 'px', 'left': '0px'});}		
		
  	searchRequest = new Request( 
  		{
  		method: 'post',
  		url: 'exploreAjax.php',
    	data: {'which': 'text', 'searchSQL':this.search_vars},
    	encoding:'UTF-8',
  		autoCancel: true, 
  		async:false,  
    	onRequest: function() {}, 
  		onFailure: function() {alert('problem')}, 
    	onComplete: function(response) {
		
				var loc_vals = new Array ();
				var message;
					
				if (response)
			  	{eval ('loc_vals = ' + response);}
				
				if (message)
					{alert (message);					
					 externalFunction("text", "text", 0, this.furtherdetailsEdit);}
				else
					{
					for (var key in loc_vals) 
						{var tdiv = this.refreshTextTitle (loc_vals[key]["title"], 
							loc_vals[key]["id"]);						
					 	$(this.source + '_list').appendChild(tdiv);} 
					}
				}.bind(this)
  		});
	
		searchRequest.send(); 
  	},

	/* Create our main and navigation windows
   */
  createWindows: function(){
  add2FunctionString ("CreateWindows");
	
	
	},
	
	
	refreshTextTitle: function (title, id)
		{
		// Try to limit the titles in list to one line
		var clen = title.length;
				
		if (clen > this.wlimit)
			{title = title.substring(0,(this.wlimit - 5)) + ' ...';}
					
		var cfont = buildFont ('', title, 't3', '', 'textTitle'); 
		$(cfont).setProperty('id', 'textTitle_'+id);

		var cid = makeInput ('hidden', "id_"+id, id, 0, 0, false); 
  	
		$(cfont).appendChild(cid);	
  	this.defaultClick($(cfont));
	
		return (cfont);
		},
		
	defaultClick: function(el)
		{		
		el.addEvent('click', function(event){
			var myElements = $$('.textTitleOpen');
			myElements.each(function(item, index)
				{this.updateTextTitle(item, false)}.bind(this));
			
			var el = event.target;
			
			if (el.get('tag') == "div")
				{this.updateTextTitle($(el), true);}
			else
				{this.updateTextTitle($(el).parentNode, true);}
				
			}.bind(this));
		},
		
		
	updateTextTitle: function(el, full)
		{
		var which = 'textDetails';
		var cid = 0;
		
		if (full == 'specific')
			{which = 'textDetailsSpecific';
			 cid = el;}
		else
		  {cid = el.firstChild.nextSibling.value;}
					
  	searchRequest = new Request( 
	  	{
  		method: 'post',
  		url: 'exploreAjax.php',
    	data: {'which': which, 'cid':cid, 'textDiv': this.source},
    	encoding:'UTF-8',
  		autoCancel: true, 
  		async:false,  
    	onRequest: function() {}, 
  		onFailure: function() {alert('problem')}, 
    	onComplete: function(response) {
				var loc_vals = new Object();			
				eval ('loc_vals = ' + response);		
				
				if (full == 'specific')
					{refreshFD (loc_vals, this.source+'_furtherDetails', this.furtherdetailsEdit);}
				else if (full) //Convert simple title to text accordian
					{var newDiv = this.titleToAcc (loc_vals);
				   var newChildren = newDiv.getChildren();					 
					 removeChildrenFromNode(el);
					 $(el).addClass('textTitleOpen');
			 		 $(el).removeEvents();
				   $(el).adopt(newChildren);
					 clearTxDT(this.source+'_furtherDetails');
					 clearTxDT(this.source+'_link');
					 if (this.externalVars)
					 	{eval(this.externalVars+'["selected"]["id"] = 0');}
					 this.refreshAccordian(el);}
				else //Change title back to simple list
					{var newDiv = this.refreshTextTitle (loc_vals["title"], loc_vals["id"]);
				   var newChildren = newDiv.getChildren();
				   removeChildrenFromNode(el);
					 $(el).removeClass('textTitleOpen');
  		 		 this.defaultClick(el);
				   el.adopt(newChildren);					 
					 }
				}.bind(this)
  		});
	
		searchRequest.send();
		},
	
	refreshAccordian: function(par)
		{
		var pD = $(par).getSize();
		var wid;
		
		if (pD.x > 670)
	  	{wid = 660;}
		else
			{wid = pD.x;}
		
		$(par).setStyle('width', wid +'px');
		//$(par).getElements('.accordion').setStyle('width', pD.x - 10 + 'px');
		
	  //create our Accordion instance
  	// For IE6
		if(Browser.Engine.name == 'trident' && Browser.Engine.version == 4 ) 
	  	{var heightValue='100%';}
  	else
	    {
    	var heightValue='';
	
			var togglerName='dt.accordion_toggler_';
			var contentName='dd.accordion_content_';
	
			var counter=1;	
			var toggler=$$(togglerName+counter);
			var content=$$(contentName+counter);
	
			while(toggler.length>0)
				{
				var fd = this.source+'_furtherDetails';
				var Othis = this;
				
				// Accordion anwenden
				this.acc = new Accordion(toggler, content, {
					opacity: false,
					display: -1,
					alwaysHide: true,
					onComplete: function() {
						var element=$(this.elements[this.previous]);
						var element=$(this.elements[this.previous]);
						
						if(element && element.offsetHeight>0) 
							{element.setStyle('height', heightValue);}
						
						if (element)
							{
							var idElement = element.previousSibling;
						
							if (idElement.id == Othis.activate)
								{Othis.updateTextTitle(idElement.id, 'specific');}	
							else
								{Othis.closeChildren(idElement);
							 	Othis.selectPToggler(idElement);}						
							}
						},
					onActive: function(toggler, content) {
						toggler.addClass('open');	
						Othis.activate = toggler.id;
						clearTxDT(Othis.source+'_furtherDetails');
						clearTxDT(Othis.source+'_link');							
						},
					onBackground: function(toggler, content) {
						if(toggler.hasClass('open'))
							{
							if (toggler.id == Othis.activate)
								{Othis.activate = 0;}
							clearTxDT(Othis.source+'_furtherDetails');
							clearTxDT(Othis.source+'_link');
							if (Othis.externalVars)
					 			{eval(Othis.externalVars+'["selected"]["id"] = 0');}
						  toggler.removeClass('open');							 							 
							}
						}
					});
		
				counter++;
				toggler=$$(togglerName+counter);
				content=$$(contentName+counter);
				}
			}
		},
		
	closeChildren: function(el)
		{
		var myElements = $(el).nextSibling.getElements('dt.open');
		myElements.each(function(item, index)
			{item.fireEvent('click', item, 1);});		
		},
		
	selectPToggler: function (el)
		{					
		//Parent toggler would be
		var pTog = el.parentNode.parentNode.previousSibling;
		//var clid = false;
		
		//need to check if any of the sibilings are open
		var ud = true;
		var otherEls = $(el).parentNode.getElements('dt.open');
		otherEls.each(function(item, index)
			{if (item.hasClass('open'))
				{ud = false;}});	
		
		if (ud && pTog && !this.activate)
			{if (pTog.get('tag') == "dt" && pTog.hasClass('open'))
				{
				 this.updateTextTitle(pTog.id, 'specific');
				 }
			}
		},
	
	titleToAcc: function (vars)
		{
		var cDiv = new Element("div", {'class': ''});
	
		var pDiv = new Element('div', {'class': ''});
			$(cDiv).appendChild(pDiv); 
		var cid = makeInput ('hidden', "id_"+vars['id'], vars['id'], 0, 0, false); 
  		$(cDiv).appendChild(cid);	
	
		var acDl = new Element('dl', {'class': 'accordion', 'id': 'accordion_'+vars['id']});
			$(pDiv).appendChild(acDl);
		var acDtT = new Element('dt', {'class': 'accordion_toggler_1', 'id':vars['id']});
			$(acDl).appendChild(acDtT); 
		var acTN = document.createTextNode(vars['title']);
	 		$(acDtT).appendChild(acTN);
			
		// Accordian content goes into this one.
		var acDtC = new Element('dd', {'class': 'accordion_content_1'});
			$(acDl).appendChild(acDtC);
			
		var cont = buildTextAccSub1 (vars['content'], vars['contentLan']);
			$(acDtC).appendChild(cont);
			
		if (vars['description'])
			{var contD = document.createTextNode(vars['description']);
		 	 var p1 = new Element('p', {'class': 'justc'});
		 	 $(p1).appendChild(tftv);
		 	 $(acDtC).appendChild(p1);}
			 
		if (vars['children'])
	  	{var ch1 = buildTextAccSub2 (vars['children'], 2, 4);
		 	 $(acDtC).appendChild(ch1);}	
				
		//var br = new Element('br');
		//	$(pDiv).appendChild(br); 
			
		return (cDiv);
		}
	});
	
	
	
function refreshFD (str, pdiv, edit)
	{	
	if ($(pdiv))
		{
    var fdiv = $(pdiv);
  	  
		fdiv.getChildren().each( function(el) 
			{el.dispose();});
        
    var tdiv = new Element("div", {'id': 'imdLeft'});
      fdiv.appendChild(tdiv);
			tdiv.setStyle('width', '95%');
    var rdiv = new Element("div", {'id': 'imdRight'});
      fdiv.appendChild(rdiv);
			rdiv.setStyle('width', '5%');
			rdiv.setStyle('top', '-5px');
    
		if (str['TextIdenifier'])
    	{
    	tdiv.setStyle('display', 'block'); 
    	newTandV (tdiv, 'Identifier: ', str['TextIdenifier'], 'mlevN_1', 'st', '');
			
			if (edit)
				{var varArr = {"process":"edit", "thing_id":str['TextID'], "subpage":'220'};
  			 var edt = eventButton ('Edit', 'edit', str['TextID'], 'data.php', varArr, '');
				 $(edt).setStyle('right', '0px');
      	 rdiv.appendChild(edt);}
    	    	
    	if (!str['cats'])	{str['cats'] = ' --- ';}
    	if (!str['related'])	{str['related'] = ' --- ';}
    	
    	newTandV (tdiv, 'Categories: ', str['cats'], 'mlevN_1', 'st');
			
			var rl = buildRelatedList (tdiv, str['relatedArr'], 'lexlrela', 'Related to:', str['TextID'], 40, edit);
			var trl = buildRelatedList (tdiv, str['transcribedArr'], 'lexltran', 'Transcribed from: ', str['TextID'], 252, edit);

			//newTandV (tdiv, 'Title: ', str['TextTitle'], 'mlevN_1', 'st');
			add2DebugString("try externalFunction (\"text\", \"text\", "+str['TextID']+', '+this.furtherdetailsEdit+')');
			externalFunction("text", "text", str['TextID'], this.furtherdetailsEdit);
    	}
  	else
    	{tdiv.setStyle('display', 'none');}
		}
	}
	

function buildRelatedList (pdiv, vars, tag, title, tid, pr, edit)
	{
	var limStr = new Element("div", {
    'class': 'mlevN_1',
		'id': 'limStr'+tag});
		
	var cells = new Array;  
  var rows = new Array;	 
	
	var tft = new Element("font", {'class': 'st'});    
  var tftv = document.createTextNode(title);
  tft.appendChild(tftv);
	cells[0] = buildCell (tft, '10px', 'nowrap', 1, 1);
	
	var cno = 1;
	var tno = 0;
			
	for (var key in vars) 
		{tno++;}
		
	for (var key in vars) 
		{
		var locStr = vars[key];
			 
		if (locStr)
			{
			if (edit)
				{var oc = 'checkLink (\'delete\','+tid+', '+pr+', '+key+', '+edit+')';
				 var cls = 'link';}
			else
				{var oc = '';
				 var cls = 'tb3';}
				
			var cft = buildFont ('', locStr, cls, oc, '', true);
										
			if (cno ==1)
				{cells[1] = buildCell (cft, '100%', '', 1, 1);}
			else
				{cells[1].appendChild(cft);}
								
			if ((tno > 2 && cno == (tno - 1)) || (tno == 2 && cno < tno))
				{var xft = buildFont ('', ' and ', 't3', '', '', true);
				 cells[1].appendChild(xft);}
			else if (tno > 2 && cno < tno)
				{var xft = buildFont ('', ', ', 't3', '', '', true);
				 cells[1].appendChild(xft);}				
			cno++;
			}
		}			
			
	if (cno > 0)
		{rows[0] = buildRow (cells);
		 var tb = buildTable(rows, "limit_"+tag+"_Table");
  		tb.setAttribute("width", '100%');
  		tb.setAttribute("cellpadding", '3px');
  		tb.setAttribute("cellspacing", '0px');
  	 limStr.appendChild(tb);}
		
  pdiv.appendChild(limStr);
  limStr.setStyle('width', '100%');
  limStr.setStyle('margin-top', '3px');
	}
	


