/*
  Additional javascript functions used for the Raphael project website.
*/

function exploreRefresh () {	
	$('page').style.display = 'none';
  var winD = Window.getSize();
	var winW = winD.x, winH = winD.y;
	
	if (winW < 1025)
	  {winW = 1024;}
	if (winH < 601)
	  {winH = 600;}
		
	if ($('popupContents'))
		{popup();}
  if ($('debugPage').getStyle('display') != 'none')
    {$('debugPage').setStyle('display', 'none');}
		
	checkResolution ();	

	if (Browser.Engine.trident)
		{var sb = 20;} // Allows for the thickness of the scroll bar
	else
		{var sb = 0;}
	
	$('leftEdge').style.height = (winH) + 'px';
	$('rightEdge').style.height = (winH) + 'px';
	$('rightEdge').style.left = (winW - 35) + 'px';
	
	$('ptitle').style.top = '0px';
		
	var myP = document.getElementById('Panel');
	var myT = document.getElementById('Title');

  var fw = (winW - 45 - sb - 55);
  
  $('Title').setStyles({
    width: fw + 'px',
    height: 35 + 'px',
    top: 35 + 'px',
    left: 45 + 'px'});
  $('Panel').setStyles({
    width: fw + 'px',
    height: (winH - 105) + 'px',
    top: 85 + 'px',
    left: 45 + 'px'});
	
	$('toplinks').style.width = (winW + sb - 85 - 65) + 'px';
	$('toplinks').style.left = '110px';
	
	var pw = Math.floor(fw/2);
	var rem = fw - (pw * 2) + 10;
	
	if ($('pageleft'))
		{$('pageleft').style.width = pw + 'px';
		 $('pageleft').style.left = 0 + 'px';}		 
		 
	if ($('pageright'))
		{$('pageright').style.width = pw + 'px';
		 $('pageright').style.left = pw + rem + 'px';}
		 
	$('Panel').style.background = 'white';
	
	$('logosm').style.position = 'absolute';
	$('logosm').style.top = '2px';
	$('logosm').style.left = '45px';
	$('logosm').style.width = '60px';

	$('page').style.display = 'block';	
	}
	
function updateObjectMenu (id, fd)
	{
	add2FunctionString ('updateObjectMenu ('+id+')');

	datestart = 0;
	dateend = 0;

	if(!display_warning)
		{var display_warning = null;}
	if(!sqlLimit)
		{var sqlLimit = null;}
	
	var search_path = "ajax.php?what=details&val="+id+"&crop="+display_warning+
		"&sqllimit="+sqlLimit+"&whichdb="+whichDB+"&whichtable="+whichTable;
	//openWindow (search_path+"&function=updateObjectMenu");
	
	searchRequest = new Request( 
		{
		method: 'get',
		url: search_path,
		autoCancel: true, 
		async:true, 
    //data: { 'do' : '1' },  
    onRequest: function() { /*alert('Request made. Please wait...');*/ }, 
		onFailure: function() {alert('FAILED')}, 
    onComplete: function(response) { 
			var loc_pd = new Array ();
			
			eval ("loc_pd = "+response);
	
      //refreshCaption(loc_pd['ImageCaption']);
      
      if (showimagedetails)
        {refreshFDT (loc_pd, fd);}
			}  
    });

	if(id > 0)
		{searchRequest.send(); }
	}
	
function refreshFDT (str, fd)
	{
	if (!fd)
		{fd = 'furtherDetails';}
		
	if ($(fd))
		{
    var fdiv = $(fd);
  	  
		fdiv.getChildren().each( function(el) 
			{el.dispose();});
			
    fdiv.setStyle('width', '100%');   
		
    var itdiv = new Element("div", {'id': fd + '_imdTop'});
      fdiv.appendChild(itdiv);
			itdiv.setStyle('width', '100%');
			itdiv.setStyle('height', '24px');
			
		var tdiv = new Element("div", {'id': 'imdLeft'});
      fdiv.appendChild(tdiv);
			tdiv.setStyle('width', '100%');
			tdiv.setStyle('background', '#F8F7F4');  

		if (str['ImageFile'])
    	{
    	tdiv.setStyle('display', 'block'); 
			
			if (str['ImageFile'])
				{var ct = buildFont ('Selected Image: ', str['ImageFile'] + ' ('+str['ImageXsize']+'x'+str['ImageYsize']+'px)', 't3b', '', 'gTitle', '', 't3b');
				 itdiv.appendChild(ct);}
			else
				{newTandV (itdiv, 'Selected Image: ', '', 'fdTitle');}
   	
    	if (!str['cats'])	{str['cats'] = ' --- ';}
    	if (!str['related'])	{str['related'] = ' --- ';}
    	    	
			if (!str['ImageCaption'])
    		{str['ImageCaption'] = ' --- ';}
    		
    	newTandV (tdiv, 'Caption: ', str['ImageCaption'], 'mlevN_1', 'st');
			if (str['ImageDescription'])
    		{newTandV (tdiv, 'Description: ', str['ImageDescription'], 'mlevN_1', 'st');}
			newTandV (tdiv, 'Categories: ', str['cats'], 'mlevN_1', 'st');
    	newTandV (tdiv, 'Related to: ', str['related'], 'mlevN_1', 'st');
    	newTandV (tdiv, 'Public: ', str['Public'], 'mlevN_1', 'st');
    	}
  	else
    	{tdiv.setStyle('display', 'none');}
				
		var mySMorph = new Fx.Morph(fd);
		
		$(fd+'_imdTop').addEvent('click', function(e)
			{
			var par = $(this).parentNode;
			var cs = $(par).getSize();
			var cp = $(par).getPosition();
		
			var is = $(par).nextSibling.getSize();
			var ip = $(par).nextSibling.getPosition();
			//alert (is.y+' : '+ip.y+' : '+cp.y);
			var nt = is.y + ip.y + 1 - 129;
		
		if (cs.y > 26)
			{var ns = 24;
			 $(par).removeClass('floatframeScroll');}
		else
			{var ns = 150;
			 nt = nt - 126;
			 $(par).addClass('floatframeScroll');}
			
			mySMorph.start({height: ns + 'px', top: nt + 'px'});
			});
		}
	}
	
function newTandV (con, v1, v2, c1, c2, c3, oc1, oc2)
	{
	if (!c1)
		{c1 = 'mlevN_1';}
	if (!c2)
		{c2 = 'mlevI_1';}
	if (!c3)
		{c3 = 'mlevI_2';}
		
	var tft, tftv, tdiv;
	
	
	if (v1 || v2)
  	{tdiv = new Element("div", {'class': c1});
  	 tdiv.setStyle('height', 'auto');}  

	
	if (v1)
		{
		if ($type($(v1)) == 'element')
			{tdiv1 = $(v1);}
		else
			{
		 	tdiv1 = new Element("div", {'class': 'tdiv1'});  	 
		 	var tft1 = new Element("font", {'class': c2});    
  	 	tftv = document.createTextNode(v1);
  	 	tft1.appendChild(tftv);
  	 	tdiv1.appendChild(tft1);
  	 	tdiv.appendChild(tdiv1);
			}
    }
  
	if (v2)
		{
		if ($type(v2) == 'element')
			{tdiv2 = v2;}
		else
			{
			tdiv2 = new Element("div", {'class': 'tdiv2'});
		  var tft2 = new Element("font", {'class': c3});   
  	 	tftv = document.createTextNode(v2);
  	 	tft2.appendChild(tftv);
  	 	tdiv2.appendChild(tft2);
  	 	tdiv.appendChild(tdiv2);}
		}
	 
  if (v1 || v2)
  	{tft = new Element("br", {}); 
  	 tdiv.appendChild(tft); 
  	 con.appendChild(tdiv);
  	 tdiv.setStyle('width', '100%');
  	 tdiv.setStyle('margin-top', '3px');
  	 con.setStyle('padding-bottom', '20px');
  	
		 var xy = tdiv.getSize();
  	 var fxy = tdiv.firstChild.getSize();
		 var mi = 80;
		 
		 //if (fxy.x > 80)
		 //	{var mi = fxy.x;}
		   	 
  	 if (v2 && xy.x )
  	  {//tdiv2.setStyle('width', xy.x - mi +'px');
			 tdiv2.setStyle('left', mi +'px');  	   
			 tdiv2.setStyle('width', xy.x - 100 +'px'); 
  	 	 tdiv2.setStyle('padding-left', '5px'); 	   
  	   tdiv.setStyle('height', xy.y - 16 +'px');}
  	 }  
  	   
  if (v1 == 'Description: ')
	 	{tdiv.setStyle('border-bottom', '0px solid white');} 
	 	
  if (oc1 == 'fe')
    {tdiv.addEvent('click', function(event){alert('Full Edit')});}
  else if (oc1 == 'r90')
    {tdiv.addEvent('click', function(event){alert('Rotate by 90°, not setup yet')});} 	
  else if (oc1 == 'r180')
    {tdiv.addEvent('click', function(event){alert('Rotate by 180°, not setup yet')});} 	
  else if (oc1 == 'r270')
    {tdiv.addEvent('click', function(event){alert('Rotate by 270°, not setup yet')});} 	
  else if (oc1 == 'del')
    {tdiv.addEvent('click', function(event){alert('Delete not setup yet.')});} 		
  else if (oc1 == 'te')
    {tft2.addEvent('click', function(event){alert('cool.')});} 	
    
  if(tdiv1 && v2)
    {var th = tdiv2.getSize(); 
     var th1 = tdiv1.getSize(); 

     if ( th.y != th1.y)
       {tdiv.setStyle('height', th.y + 2 + 'px');}
    }
  }

function refreshCaption (str)
	{	
	$('captions').getChildren().each( function(el) 
		{el.dispose();});

  if (str)
    {
    $('captions').setStyle('display', 'block');
	  var tft = new Element("font", {'class': 't2'});    
    var tftv = document.createTextNode(''+str);
  	  tft.appendChild(tftv);
  	$('captions').appendChild(tft); 
    }
  else
    {
    $('captions').setStyle('display', 'none');
    }
	}
	

function buildNewImageForm (parentDiv, formDiv, vars)
	{/*
  var sD = $(parentDiv).getSize();
	var sW = sD.x, sH = sD.y;
	  
	var th = 80;
	
	//Build Search Div
  $(searchDiv).setStyles({
    'height': th + 'px', 
    'top': '0px', 'left': '0px'});	
		
	var opts = {"image":"Image Details", "object":"Object Details", "keyword":"Category"};
	//alert(vars);
	var limStr = "";//arrToString (vars);
	//var post = {"searchObjects":{"0":"ng168"},"searchImages":{},"searchCategories":{"0":"vis"},"searchTexts":{"0":"vis"},"displayOption":"1"};
	
	for (var key in vars) 
		{
		for (var key2 in vars[key])
			{
			var locStr = "";
			
			if (key == "searchObjects")
			 {locStr = "Object:'"+vars[key][key2]+"'";}
			else if (key == "searchImages")
			 {locStr += "Image:'"+vars[key][key2]+"'";}
			else if (key == "searchCategories")
			 {locStr += "Category:'"+vars[key][key2]+"'";}
			 
			if (locStr)
				{if (limStr) {limStr = limStr + ", " + locStr;}
				 else {limStr = locStr;}}
			}			
		}
			
	var ob1 = buildFont ('Search Images: ', '', 'ptitle3', ''); 
	var ob2 = array2dropdown ("imlimitby", opts, 0, "", ""); 
	var ob3 = makeInput ('text', "imkeysearch", "enter value", 150, "", 0); 
	$(ob3).addEvent('focus', function(event){
		if (document.getElementById('imkeysearch').value == 'enter value')
			{document.getElementById('imkeysearch').value='';}});
	$(ob3).addEvent('keydown', function(event){
		if (event.key == "enter")
			{$('imgosearch').fireEvent('click', $('imgosearch'), 1);}
		});
	
	var ob4 = makeInput ('button', "imgosearch", "Go", 30, "", 0); 	
	$(ob4).addEvent('click', function(event){
 		var tcell = $(this).parentNode;
		var tinp = $(tcell).previousSibling.firstChild;		
		var tsel = $(tcell).previousSibling.previousSibling.firstChild;		
		
		if (tsel.value == "object")
			{var newArr = {"searchObjects":{"0":tinp.value}};}
		else if (tsel.value == "image")
			{var newArr = {"searchImages":{"0":tinp.value}};}
		else //if (tsel.value == "keyword")
			{var newArr = {"searchCategories":{"0":tinp.value}};}
		
		array2hidden ('pageVars', post);
		array2hidden ('pageVars', newArr);
		
		newArr = {"test":"ok"};
		array2hidden ('pageVars', newArr);
		
		document.pageVars.submit();		
  });
	
	var ob5 = makeInput ('button', "cisearch", "Clear Search", 15, "", 0);
	var ob6 = buildFont ('Images Limited by: ', '', 'cls', ''); 
	var ob7 = buildFont ('', limStr, 'cls', ''); 
	
  var cells = new Array;  
  var rows = new Array;
	
	cells[0] = buildCell (ob1, '10px', 'nowrap', 1, 1);
	cells[1] = buildCell (ob2, '10px', 'nowrap', 1, 1);
	cells[2] = buildCell (ob3, '10px', 'nowrap', 1, 1);
	cells[3] = buildCell (ob4, '', '', 1, 1);
	rows[0] = buildRow (cells);
  cells = new Array;
	cells[0] = buildCell (ob6, '10px', 'nowrap', 1, 1);
	cells[1] = buildCell (ob7, '10px', '', 3, 1);
	rows[1] = buildRow (cells);
	
  var tb = buildTable(rows, "imSearchTable");
  	tb.setAttribute("cellpadding", '5px');
  //tb.setAttribute("id", 'imageTable_'+thisVals["id"]);
  //tb.setAttribute("border", '1px');
  $(searchDiv).appendChild(tb);		
		
	//Build IIP Gallery	
  $(imDiv).setStyles({
    'height': sH - th + 'px', 
    'top': th + 'px', 'left': '0px'});	 		
	
  im1 = new IIP_Gallery( imDiv, {
  	image: 'blank',
  	searchSQL: vars,
  	zoom: 1,
  	centerzoom: 1,
  	render: 'random',
  	hideNav: false,
  	hideIcon: false
  	}); 
		*/ 
	}
