<?php

require_once( "header.php" );

setGlobals();

		
//emptyDB();
emptyDBSub (42, false);

// This function will slowly go through and delete all "things" that 
// have been entered into the database. where "things" are or are 
// children of Objects, Digital Flies, Events, Actors, Locations and 
// Digital Texts. All other data should be left.
function emptyDB ()
  {   
  $this_db = new DB( $GLOBALS["whichdb"] );  
	
	$ids = getTypeAllChildren (array(1,2,3,4,5,6,220)); 
  $idstr = implode(",", $ids); 
	
	$sql = "select * from thing where thing_type IN ($idstr)";
	
  $this_db->query($sql);
  while ($myrow = $this_db->next())
		{emptyDBSub ($myrow["thing_id"]);}
		
	removeOrphans ();
  }
	
function removeOrphans ()
	{ 
	echo "<h1>Remove Orphans</h1>";
	$this_db = new DB( $GLOBALS["whichdb"] );  
	
	// Thing type 255 no longer used
	$sql = "SELECT * FROM `thing`
	WHERE thing_type IN (255)";
	
	echo "<h2>Step 1: old types => (255)</h2><br>$sql<br><br>";
	$this_db->query($sql);
  while ($myrow = $this_db->next())
		{echo $myrow["thing_id"]."<br>";
		 emptyDBSub ($myrow["thing_id"]);} 
		
	// Remove things with no properties at all
  $sql = "SELECT *
	FROM `type` , `thing`
	LEFT JOIN triple ON thing_id = subject
	WHERE type_id = thing_type
	AND `triple`.`object` IS NULL ";
	
	echo "<h2>Step 2: Thing with no properties</h2><br>$sql<br><br>";
	$this_db->query($sql);
  while ($myrow = $this_db->next())
		{echo $myrow["thing_id"]."<br>";
		 deleteThing ($myrow["thing_id"]);}
		
	// Orphan "content" things with no parent
	$sql = "SELECT *  FROM `thing` 
LEFT JOIN `triple` ON 
 `triple`.`object` = `thing`.`thing_id`
 AND `triple`.`predicate` = 237
WHERE 
 `thing`.`thing_type` = 265";
 
 echo "<h2>Step 3: Orphan \"Contents\"</h2><br>$sql<br><br>";
 	$this_db->query($sql);
  while ($myrow = $this_db->next())
		{
		if (!$myrow["subject"])
			{echo "TYPE: [265]: ".$myrow["thing_id"]."<br>";
				emptyDBSub ($myrow["thing_id"]);}
		else
			{echo "MISSED: [265]: @@".$myrow["subject"]."@@<br>";}
		}
		
	// Orphan "identifiers" things with no parent
	$sql = "SELECT *  FROM `thing` 
		LEFT JOIN `triple` ON 
 		`triple`.`object` = `thing`.`thing_id`
 		AND `triple`.`predicate` = 17
		WHERE `thing`.`thing_type` = 235";
		
 echo "<h2>Step 4: Orphan \"Identifers\"</h2><br>$sql<br><br>";
 	$this_db->query($sql);
  while ($myrow = $this_db->next())
		{
		if (!$myrow["subject"])
			{echo "TYPE: [235]: ".$myrow["thing_id"]."<br>";
				emptyDBSub ($myrow["thing_id"]);}
		else
			{echo "PASSED: [235]: @@".$myrow["subject"]."@@<br>";}
		}
	/*		
	// Orphan "content" things with no parent
	$sql = "SELECT *  FROM `thing` 
LEFT JOIN `triple` ON 
 `triple`.`object` = `thing`.`thing_id`
 AND `triple`.`predicate` = 18
WHERE 
 `thing`.`thing_type` = 56 ";
 
 	$this_db->query($sql);
  while ($myrow = $this_db->next())
		{
		if ($myrow["subject"] == "NULL")
			{emptyDBSub ($myrow["thing_id"]);}
		}
		*/
	}

function emptyDBSub ($thing_id, $echo=false)
  {   
  $this_db = new DB( $GLOBALS["whichdb"] );  
  $this_db2 = new DB( $GLOBALS["whichdb"] );  
  
  $propArr = getRelatedProperties (0, "all");
	
  $props = implode(",", array_keys($propArr));
	   
  $query = "
    SELECT 
`t1`.`triple_id` AS `tid1` , 
`t1`.`subject` AS `sub1` , 
`t1`.`predicate` AS `pre1` , 
`t1`.`object` AS `obj1`,
 
`t2`.triple_id AS `tid2` , 
`t2`.subject AS `sub2` , 
`t2`.predicate AS `pre2` , 
`t2`.object AS `obj2`,
 
`t3`.triple_id AS `tid3` , 
`t3`.subject AS `sub3` , 
`t3`.predicate AS `pre3` , 
`t3`.object AS `obj3`

FROM thing
JOIN `triple` AS
t1 ON thing_id = `t1`.`subject`
JOIN `triple` AS
`t2` ON t1.object = `t2`.subject
LEFT JOIN `triple` AS
`t3` ON t2.object = `t3`.subject

WHERE 1
AND thing_id = $thing_id
AND `t1`.`predicate`
IN ( $props )
";

  $query2 = "
    SELECT 
`t1`.`triple_id` AS `tid1` , 
`t1`.`subject` AS `sub1` , 
`t1`.`predicate` AS `pre1` , 
`t1`.`object` AS `obj1`, 
`t3`.`property_name` AS `pre1_name`

FROM thing
JOIN `triple` AS
t1 ON thing_id = `t1`.`subject`
JOIN `property` AS
`t3` ON t1.predicate = `t3`.property_id

WHERE 1
AND thing_id = $thing_id
AND `t1`.`predicate`
NOT IN ( $props )
";

  $query3 = "
    SELECT 
`t1`.`triple_id` AS `tid1` , 
`t1`.`subject` AS `sub1` , 
`t1`.`predicate` AS `pre1` , 
`t1`.`object` AS `obj1`

FROM `triple` AS t1

WHERE 1
AND `t1`.`object` = $thing_id
AND `t1`.`predicate` NOT IN ( $props )
"; 
	 
	if ($echo)
		{echo "$query<br><br>";
		 echo "$query2<br><br>";
		 echo "$query3<br><br>";}

  $rthings = array();
  $rtriples = array();

	//Search for all names, identifiers, etc ..
  $this_db->query($query);
  while ($myrow = $this_db->next())
    {
		$rthings[$myrow["sub1"]] = $myrow["sub1"];
    $rtriples[$myrow["tid1"]] = $myrow["tid1"];
      
		//Check if the actual values are used elsewhere, 
		//if they are don't add them for deletion
		if (additionalLinkCheck ($myrow["sub1"], $props, $myrow["obj1"]))
      {$rtriples[$myrow["tid2"]] = $myrow["tid2"];
       $rtriples[$myrow["tid3"]] = $myrow["tid3"];  
       $rthings[$myrow["sub2"]] = $myrow["sub2"];
       $rthings[$myrow["sub3"]] = $myrow["sub3"];}    
    }

  //Search for all straight references from this thing
  $this_db->query($query2);
  
  while ($myrow = $this_db->next())
    {$rtriples[$myrow["tid1"]] = $myrow["tid1"];} 
    	
  //Search for all straight references to this thing 
  $this_db->query($query3);
  
  while ($myrow = $this_db->next())
    {$rtriples[$myrow["tid1"]] = $myrow["tid1"];}
 
 		
	if ($rthings) {echo "Delete Things:<br>";}
  foreach ($rthings as $key => $id1)
		{
		if ($echo)
			{echo "$id1 => ".getTypeName (getThingType ($id1))."<br>";}
		else
			{deleteThing ($id1);}
		}
	
	if ($rtriples) {echo "Delete Triples:<br>";}
  foreach ($rtriples as $key => $id2)
		{		
		if ($echo)
			{print_r (getTriple ($id2)); echo "<br>";}
		else
			{deleteTriple ($id2);}
		}
		
	if (!$echo) {deleteThing ($thing_id);}
  }
	
?>
